//+------------------------------------------------------------------+
//|                                                     EAHeader.mqh |
//|                                                        iamgotzaa |
//|                               http://iamforextrader.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "iamgotzaa"
#property link      "http://iamforextrader.blogspot.com"
#property strict

#include <SmallFunc.mqh>
#include <MQL4OBJ.mqh>
#include <LastOrder.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum RobotStateName
  {
   Idle,Single,Hold,Retain,Counter,Average,Reverse
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum TradeSignalCode
  {
   cbuy,csell,cnone,fbuy,fsell,cbuy2,csell2
  };
RobotStateName state;

int LastTicket;
//int PreviousTicket;

int bars;
int barm1;
int barm5;
int barm15;
int barm30;
int barh1;
int barh4;
int bard1;
int barw1;

bool NewBar;

int RDIGITS;

string debugmessage="";
//+------------------------------------------------------------------+
int MagicNumber;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Init()
  {
   MagicNumber=AutomaticIDGenerate();
   RDIGITS=(int)MathPow(10,Digits);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void debug_on_tick()
  {
   debugmessage="";
  }
//+------------------------------------------------------------------+
void debuginfo(string &db,string msg,bool newline=false)
  {
   if(newline==false)
     {
      db=db+msg;
     }
   if(newline==true)
     {
      db=db+msg+"\n";
     }
  }
//+------------------------------------------------------------------+

bool CheckNewBar(void)
  {
   if(iBars(NULL,0)>bars)
     {
      bars=iBars(NULL,0);
      return(true);
     }
   else
     {
      return(false);
     }
  }
//+------------------------------------------------------------------+
void SetHedgePairs(string &pair[])
  {

   if(Symbol()=="AUDCAD"){ ArrayResize(pair,3); pair[0]="GBPAUD";pair[1]="GBPNZD";pair[2]="CADJPY";}
   if(Symbol()=="AUDCHF"){ ArrayResize(pair,3); pair[0]="CHFJPY";pair[1]="EURAUD";pair[2]="EURNZD";}
   if(Symbol()=="AUDJPY"){ ArrayResize(pair,3); pair[0]="NZDCAD";pair[1]="GBPAUD";pair[2]="USDCAD";}
   if(Symbol()=="AUDNZD"){ ArrayResize(pair,3); pair[0]="NZDCAD";pair[1]="NZDCHF";pair[2]="NZDJPY";}
   if(Symbol()=="CADCHF"){ ArrayResize(pair,3); pair[0]="CHFJPY";pair[1]="GBPCAD";pair[2]="EURAUD";}
   if(Symbol()=="CADJPY"){ ArrayResize(pair,3); pair[0]="NZDCAD";pair[1]="NZDUSD";pair[2]="USDCHF";}
   if(Symbol()=="CHFJPY"){ ArrayResize(pair,3); pair[0]="CADCHF";pair[1]="AUDCHF";pair[2]="NZDCHF";}
   if(Symbol()=="EURAUD"){ ArrayResize(pair,3); pair[0]="CADCHF";pair[1]="NZDCHF";pair[2]="USDCAD";}
   if(Symbol()=="EURCAD"){ ArrayResize(pair,3); pair[0]="CADCHF";pair[1]="USDCHF";pair[2]="AUDCHF";}
   if(Symbol()=="EURCHF"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="GBPCHF";}
   if(Symbol()=="EURGBP"){ ArrayResize(pair,3); pair[0]="GBPCHF";pair[1]="GBPNZD";pair[2]="USDCAD";}
   if(Symbol()=="EURJPY"){ ArrayResize(pair,3); pair[0]="AUDCHF";pair[1]="NZDCAD";pair[2]="NZDCHF";}
   if(Symbol()=="EURNZD"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="AUDCAD";}
   if(Symbol()=="GBPAUD"){ ArrayResize(pair,3); pair[0]="NZDCAD";pair[1]="NZDCHF";pair[2]="NZDJPY";}
   if(Symbol()=="GBPCAD"){ ArrayResize(pair,3); pair[0]="NZDUSD";pair[1]="USDCHF";pair[2]="AUDCHF";}
   if(Symbol()=="GBPCHF"){ ArrayResize(pair,3); pair[0]="EURGBP";pair[1]="NZDUSD";pair[2]="USDCAD";}
   if(Symbol()=="GBPJPY"){ ArrayResize(pair,3); pair[0]="AUDCAD";pair[1]="AUDCHF";pair[2]="NZDCAD";}
   if(Symbol()=="GBPNZD"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="AUDCAD";}
   if(Symbol()=="NZDCAD"){ ArrayResize(pair,3); pair[0]="GBPNZD";pair[1]="AUDNZD";pair[2]="AUDJPY";}
   if(Symbol()=="NZDCHF"){ ArrayResize(pair,3); pair[0]="GBPUSD";pair[1]="GBPNZD";pair[2]="GBPJPY";}
   if(Symbol()=="NZDJPY"){ ArrayResize(pair,3); pair[0]="GBPNZD";pair[1]="GBPAUD";pair[2]="AUDNZD";}
   if(Symbol()=="AUDUSD"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="USDJPY";}
   if(Symbol()=="EURUSD"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="GBPCHF";}
   if(Symbol()=="GBPUSD"){ ArrayResize(pair,3); pair[0]="USDCAD";pair[1]="USDCHF";pair[2]="USDJPY";}
   if(Symbol()=="USDCAD"){ ArrayResize(pair,3); pair[0]="EURUSD";pair[1]="GBPUSD";pair[2]="AUDUSD";}
   if(Symbol()=="USDCHF"){ ArrayResize(pair,3); pair[0]="EURUSD";pair[1]="GBPUSD";pair[2]="EURAUD";}
   if(Symbol()=="USDJPY"){ ArrayResize(pair,3); pair[0]="AUDUSD";pair[1]="NZDUSD";pair[2]="GBPUSD";}

  }
//+------------------------------------------------------------------+
void EA_Init()
  {
   MagicNumber=AutomaticIDGenerate();

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void LoopModifyTP(double tp)
  {

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         tp=NormalizeDouble(tp,(int)MarketInfo(OrderSymbol(),MODE_DIGITS));
         //if(OrderMagicNumber()==MAGIC && OrderSymbol()==Symbol())
         if(OrderSymbol()==Symbol())
           {
            if(OrderTakeProfit()==0 || OrderTakeProfit()!=tp)
              {
               int mod=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,OrderExpiration());
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
void LoopTrailing(int type,int mark=50,int move=20)
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==type && OrderSymbol()==Symbol())
           {
            stoplosswheelbarrel(OrderTicket(),mark*Point,move*Point);

           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HP(int bar=5,int startx=1,int timeframe=PERIOD_M15)
  {
   return(High[iHighest(Symbol(),timeframe,MODE_HIGH,bar,startx)]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LP(int bar=5,int startx=1,int timeframe=PERIOD_M15)
  {
   return(Low[iLowest(Symbol(),timeframe,MODE_LOW,bar,startx)]);
  }
//+------------------------------------------------------------------+
double PercentileSafetyLevel(int side,int barnumber)
  {
   double ceiling=HP(barnumber,2);
   double floorx=LP(barnumber,2);
   double mkt=Bid;
   double percentile=0;
   double per_b;
   double per_s;
   string t="";
   per_b=(mkt-floorx)/(ceiling-floorx)*100;
   per_s=(ceiling-mkt)/(ceiling-floorx)*100;
   if(side==OP_BUY)
     {
      percentile=per_b;
     }
   if(side==OP_SELL)
     {
      percentile=per_s;
     }
   percentile=NormalizeDouble(percentile,2);
   return(percentile);
  }
//+------------------------------------------------------------------+
//| My function                                                      |
//+------------------------------------------------------------------+
// int MyCalculator(int value,int value2)
//   {
//    return(value+value2);
//   }
//+------------------------------------------------------------------+
//+---function pts(n)------------------------------------------------+
double pts(int number)
  {
   return(number*Point);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double pips(int number)
  {
   return(number*Point*10);
  }
//int pnts(string _symbol,double price)
//{
//   return((int)price*MathPow(10,MarketInfo(_symbol,MODE_DIGITS)));   
//}

double CandleRange(int bar=5,int timeframe=PERIOD_M15)
  {
   return(HP(bar,1,PERIOD_M15)-LP(bar,1,PERIOD_M15));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HLP(int bar=5,int start=1)
  {
   return(Low[iHighest(Symbol(),0,MODE_HIGH,bar,start)]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LHP(int bar=5,int start=1)
  {
   return(High[iLowest(Symbol(),0,MODE_HIGH,bar,start)]);
  }
//bool IsNewBar(int period=60)
//{
//   int bar;
//   if(iBars(NULL,period)>bar)
//   {
//      return(true);
//      bar=iBars(NULL,period);
//   }
//   return(false);
//}


//+----------------------------------------------+
// funciton Gap(..)
//+----------------------------------------------+
// returns the absolute distance in points between two price of specfied Symbol
//int Gap(string symbol,double p1, double p2)
//{
//   int digit=(int)MarketInfo(symbol,MODE_DIGITS);
//   double gap;
//   int gappts;
//   gap=MathAbs(p1-p2);
//   gappts=gap*MathPow(10,digit);
//   return(gappts);
//}


double GetSlope(double &array[])
  {
//using linear regression method
   double slope_TF1=0;
   int N=0;
   double sumX=0,sumY=0;
   double xbar=0,ybar=0;
   double sumXY=0,sumXpow=0;

   N=ArraySize(array);
//calculate X-bar   
//calculate Y-bar
//calculate sum or XiYi   
//calculate N*X-bar*Y-Bars   
//calculate sum of Xi^2   
//calcuate N*X-bar^2   
   for(int i=0;i<N;i++)
     {
      sumX=sumX+i;
      sumY=sumY+array[i];

      sumXY=sumXY+(i*array[i]);
      sumXpow=sumXpow+(MathPow(i,2));
     }
   xbar=sumX/N;
   ybar=sumY/N;

   slope_TF1=(sumXY-N*xbar*ybar)/(sumXpow-N*MathPow(xbar,2));
   return(-slope_TF1);
  }
//close[x] to last high
//return distnace in decimal
double CH(int n)
  {
   return(Close[n]-High[1]);
  }
//close[x] to last low
//return distnace in decimal
double CL(int n)
  {
   return(Close[n]-Low[1]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void NakedBuy(double lotsx)
  {
   int t=OrderSend(Symbol(),OP_BUY,lotsx,Ask,2,0,0,NULL,MagicNumber);
  }
//+------------------------------------------------------------------+
void NakedSell(double lotsx)
  {
   int t=OrderSend(Symbol(),OP_SELL,lotsx,Bid,2,0,0,NULL,MagicNumber);
  }
  //+------------------------------------------------------------------+
bool RangeDeployKeeper(int side)
  {
//---
   double disthigh=0;
   double distlow=0;
   disthigh=HP(20)-Bid;
   distlow=Bid-LP(20);
   int barhigh=0,barlow=0;
   double max=0;
   double min=100000;
   for(int i=0;i<20;i++)
     {
      if(High[i]>max)
        {
         max=High[i];
         barhigh=i;
        }
      if(Low[i]<min)
        {
         min=Low[i];
         barlow=i;
        }
     }
//---
//---
//ranging
   bool pointingDown=false;
   bool pointingUp=false;
   if(disthigh>200*Point && distlow>200*Point)
     {
      //---
      //bounce down
      if(barhigh<barlow)
        {
         pointingDown=true;
        }
      if(barhigh>barlow)
        {
         pointingUp=true;
        }
     }
//---
   if(pointingDown && side==OP_BUY)
     {
      return(false);
     }
   else
   if(pointingUp && side==OP_SELL)
     {
      return(false);
     }
   else
     {
      return(true);
     }
//---

  }
//+------------------------------------------------------------------+
