//+------------------------------------------------------------------+
//|                                                        Feb10.mq4 |
//|                                             Komgrit Sungkhaphong |
//|                               http://iamforextrader.blogspot.com |
//+------------------------------------------------------------------+

//version50
// -allow user to run multiple instance of bot for the same pair, by specifying the MAGIC number

//version60
// -reduce chan

//v66ba
//-make it compatible to mt4 build 6XX
//-4-digit broker compatible

#property copyright "Komgrit Sungkhaphong"
#property link      "http://iamforextrader.blogspot.com"
/*
#include "libraries\Trade.mq4"
#include "libraries\OAmq4"
#include "libraries\Lib.mq4"
*/
#include <LastOrder.mqh>
#include<Trade.mq4>
#include <OA.mq4>
//#include "Lib.mq4"

#include <EAHeader.mqh>

#define currentversion "80A"
#define version_unique_id  11;
input bool ENCisACrime=true;
#define state_idle         0
#define state_await_buy    500
#define state_await_sell    600
#define state_ecn_buyaddtp    700
#define state_ecn_buyaddstop  750
#define state_ecn_selladdtp    800
#define state_ecn_selladdstop  850
#define state_buy1          1000
#define state_sell1         2000
#define state_buy2          1800
#define state_sell2         2800

#define state_buy2_hold     1900
#define state_sell2_hold    2900

#define state_revbuy_tradesell  1500
#define state_revsell_tradebuy  2500

#define state_revbuy_tradesell_trail  1599
#define state_revsell_tradebuy_trail  2599


//+------------------------------------------------------------------+
//| User Define variables                                   |
//+-----------------------------------------------------------------+
input bool UseAutoID=true;
input int User_define_Bot_ID=12346357;
input int UserDefine_SpreadTooHigh=500;   //Points
input double init_lot_size=0.01;
input double exponent=1.44;
input double squeeze_factor=0.3;

input int atr_range=24;
input int candles_range=12;
input int Calm_candles=8;
input string Calm_range_info="unit in point";
input int Calm_range=200;

//input int D1_Candles=5;
input int D1_atr_range=10;

input double HoldMinutes=60;
input int  High_Or_Low_Diff=40;

input double ShutDownPercent=5.00;

input int markPts=30;
input int movePts=5;
int atr_period=60;
input int mindistanceRecov=200;//For ke,Re order 1 & 2, minimum distance
input double multiplier3=1.5;//Multiplier for order 3rd
input double multiplier4=1.6;//Multiplier for order 4th
input double multiplier5=1.7;//Multiplier for order 5th
input double multiplier6=1.8;//Multiplier for order 6th
input double multiplier7=1.9;//Multiplier for order 7th
input double multiplier8=2;//Multiplier for order 8th
input double multiplier9=2.1;//Multiplier for order 9th
input double multiplier10=2.2;//Multiplier for order 10th, after ten, u'r f**ck

double maxPrice,minPrice;
int minInd,maxInd;
double multk[11];
//+------------------------------------------------------------------+
//| Order Issue Interlocking                                                 |
//+------------------------------------------------------------------+

datetime timestamp_buy;
datetime timestamp_sell;
datetime timestamp_close;
int MinutesToUnlock_buy;
int MinutesToUnlock_sell;
//+------------------------------------------------------------------+
//| Multiple Orders Control                                                 |
//+------------------------------------------------------------------+
//    [0][]=ticket number
//    [1][]=lots
//    [2][]=price
double OrderAcc_buy[25][3];
double OrderAcc_sell[25][3];
int lastticket;
double pl;              //pips
double cummpl;
double thisBreakEven;   //price
double distance_Loss;   //pips
double distance_Gain;   //pips
double lots;
double propose_new_stoploss;
double expect_stoploss;
double target_gain;
double new_target_price;
double new_stop_loss;
bool calbreak_flag;
bool TP_is_too_low=false;

double max_gain;
double max_loss;
double estimate_max_loss;
double RRR;
int bbb; //bar count in Isnewbar
datetime laststamp;
datetime BlockBuyUntilTime;
datetime BlockSellUntilTime;
datetime MultiOrderStateTimeStamp;
datetime MultiOrderStateTimeStamp_buy;
datetime MultiOrderStateTimeStamp_sell;
int      MultiOrderState_Age;
double ThisOpenPrice;
double PercentileSafetyLevel;
int CMD;
double newMark;
//+------------------------------------------------------------------+
//| State machine variables                                                  |
//+------------------------------------------------------------------+
int MachineState;
string now;
double tickcount,_tickcount;
//+------------------------------------------------------------------+
//| General variables                                                  |
//+------------------------------------------------------------------+
static int MAGIC;
string comment_string;
string comments;
int RetError;
double SPREAD;
double X45;
string units;
double DECPIP;
string BROKER45;
//+------------------------------------------------------------------+
//| Indicators                                                 |
//+------------------------------------------------------------------+
double ATR;
double fastATR;
double ATR_Slope;
double dailyATR;
double lowerbound;
double upperbound;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(UseAutoID==true)
     {
      MAGIC=AutomaticIDGenerate();
      MAGIC=MAGIC+version_unique_id;
     }
   else
     {
      MAGIC=User_define_Bot_ID;
     }
//MAGIC=MAGIC_LIST_BY_SYMBOL();
   multk[0]=1;
   multk[1]=1;
   multk[2]=1;
   multk[3]=multiplier3;
   multk[4]=multiplier4;
   multk[5]=multiplier5;
   multk[6]=multiplier6;
   multk[7]=multiplier7;
   multk[8]=multiplier8;
   multk[9]=multiplier9;
   multk[10]=multiplier10;

//v66ba 
//create one point to pip for 4 digit broker
   switch(Digits)
     {
      case  5:
        {
         BROKER45="5-digits";
         X45=1;
         units="Point";
         DECPIP=MathPow(10,Digits);
         Print("v66ba: You are running with 5 digit broker server.");
         break;
        }
      case  4:
        {
         BROKER45="4-digits";
         X45=0.1;
         units="Pip";
         DECPIP=MathPow(10,Digits);
         Print("v66ba: You are running with 4 digit broker server.");
         break;
        }
      case  3:
        {
         BROKER45="3-digits";
         X45=0.01;
         units="10Pip";
         DECPIP=MathPow(10,Digits);
         Print("v66ba: You are running with 3 digit broker server.");
         break;
        }
      default:
        {
         BROKER45="5-digits";
         X45=1;
         units="Point";
         DECPIP=MathPow(10,Digits);
         break;
        }
     }
   createCommentBlockGraphic();
   if(IsDemo()) comment_string="DEMO"+"\n";
   else comment_string="LIVE"+"\n";
   comment_string=comment_string+"Magic Number="+IntegerToString(MAGIC)+"\n";
//----  Account detail
   string _account_string;
   _account_string="Broker:"+AccountCompany()+"\n";
   _account_string=_account_string+"ID:"+IntegerToString(AccountNumber())+"\n";
   _account_string=_account_string+"Name:"+AccountName()+"\n";

   comment_string=comment_string+_account_string;
   Comment(comment_string);

   BlockBuyUntilTime=TimeCurrent()-1*60*60;
   BlockSellUntilTime=TimeCurrent()-1*60*60;

//---- init the MachineState
   MachineState=state_idle;

   int livebuy=order_count_live_type2(MAGIC,OP_BUY);
   int livesell=order_count_live_type2(MAGIC,OP_SELL);

   if(livebuy==1 && livesell==0)
     {
      MachineState=state_buy1;
     }
   if(livebuy==0 && livesell==1)
     {
      MachineState=state_sell1;
     }
   if(livebuy>=2 && livesell==0)
     {
      MachineState=state_buy2;
     }
   if(livebuy==0 && livesell>=2)
     {
      MachineState=state_sell2;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   RefreshRates();

//v66ba
   SPREAD=Ask-Bid;
//SPREAD=SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
   status("You are running "+BROKER45);

   int power;

//----Info
   comments="";
   tickcount=GetTickCount();
   double pAccLoss=(AccountEquity()-AccountBalance())/AccountBalance()*100;
   status("%loss="+DoubleToString(pAccLoss,2)+"%");
   lastticket=get_last_order(lastticket);
   if(pAccLoss<-ShutDownPercent)
     {
      //close_symbol();
     }
//----Graphics

   lastticket=get_last_order(MAGIC);
//----Time Control
//   MinutesToUnlock_buy=(int)(timestamp_buy+HoldMinutes*60-TimeCurrent());
//   MinutesToUnlock_buy=MinutesToUnlock_buy/60;
//   if(MinutesToUnlock_buy<0) MinutesToUnlock_buy=0;
//
//   MinutesToUnlock_sell=(int)timestamp_sell+HoldMinutes*60-TimeCurrent();
//   MinutesToUnlock_sell=MinutesToUnlock_sell/60;
//   if(MinutesToUnlock_sell<0) MinutesToUnlock_sell=0;
//----name of State Machine   
//    This will be shown on the trading comment view

//#statenamecode #stateshort #abbr
   Run_CurrentStateShortCode();
//set tate order command for new order either OP_BUY or OP_SELL
//#ordercommand
   Run_OrderCommand();
//#statetransition #transition
   Run_State_Transition();
//#timestampcontrol
   Run_TimeStampControl();
//Comment message generating sections
//#commentary #commentmessage
   Run_Comment();
//----Actions State Machine
   bool neabarm15=false;
   if(iBars(Symbol(),PERIOD_M15)>barm15)
     {
      neabarm15=true;
      barm15=iBars(Symbol(),PERIOD_M15);
     }
//---

   maxPrice=-1;
   minPrice=100000;
//searching for swing
   int r=20;

   double averagemove=0;
   for(int i=0;i<r;i++)
     {
      double high=iHigh(Symbol(),PERIOD_M1,i);
      double low=iLow(Symbol(),PERIOD_M1,i);
      double close=iOpen(Symbol(),PERIOD_M1,i);
      if(high>maxPrice)
        {
         maxPrice=high;
         maxInd=i;
        }
      if(low<minPrice)
        {
         minPrice=low;
         minInd=i;
        }
      //averagemove=averagemove+MathAbs(high-low);
     }
//averagemove=averagemove/r;

   status("maxInd="+IntegerToString(maxInd)+" "+"minInd="+IntegerToString(minInd));
   bool groupbuy=false;
   bool groupsell=false;
   int c=0,d=0;
   for(int i=0;i<32;i++)
     {
      if(iCustom(Symbol(),PERIOD_M15,"Quantum",15,1,i+1)>0)
        {
         c++;
        }
      if(iCustom(Symbol(),PERIOD_M15,"Quantum",15,0,i+1)>0)
        {
         d++;
        }
     }
   if(c>=5)
     {
      groupbuy=true;
     }
   if(d>=5)
     {
      groupsell=true;
     }
//---

   switch(MachineState)
     {
      case state_idle:
        {
         //----State's action
         //create range upper and lower bounds
         max_gain=0;
         max_loss=0;

         //#spreadlock
         //if spread is more than 60, this bot would do nothing. 
         if(SPREAD>UserDefine_SpreadTooHigh*Point)
           {
            //v66ba

            Comment("Point="+DoubleToStr(Point,Digits)+" Spread is too high ="+DoubleToString(SPREAD,Digits)+" (limit="+DoubleToStr(UserDefine_SpreadTooHigh*Point,Digits)+")");
            return(0);
           }
         //#entry #entries
         double prevbarsize=High[1]-Low[1];
         double atr14=iATR(Symbol(),0,14,0);
         if(IsNoPosition() && TimeCurrent()>timestamp_close+HoldMinutes*60)
           {
            //-----trigger trade buy
            //if(CandleRange(5)>Calm_range*Point)
              {
               expect_stoploss=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               double expect_target=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               if(TimeCurrent()>BlockBuyUntilTime)
                 {
                  PercentileSafetyLevel=PercentileSafetyLevel(OP_BUY,24);
                  //if(PercentileSafetyLevel<30)
                  //if()
                  //if(iStochastic(Symbol(),0,5,3,3,MODE_EMA,STO_CLOSECLOSE,MODE_SIGNAL,1)<20)
                    {
                     //if(iClose(Symbol(),PERIOD_M1,1)>HP(3))

                     //if(Bid<LP(3))
                     //if( minInd<=2 && maxInd>=9)
                     //if(iAC(NULL,0,0)>iAC(NULL,0,1))
                     if(groupbuy && !groupsell)
                       {
                        lastticket=Trade_Market(OP_BUY,timestamp_buy,init_lot_size,0,0,"ke");
                        return(0);
                       }
                    }
                 }
              }
            //-----trigger trade sell
            //if(CandleRange(5)>Calm_range*Point)
              {
               expect_stoploss=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               double expect_target=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);

               if(TimeCurrent()>BlockSellUntilTime)
                 {
                  PercentileSafetyLevel=PercentileSafetyLevel(OP_SELL,24);
                  //if(PercentileSafetyLevel<30)
                  //if(iStochastic(Symbol(),0,5,3,3,MODE_EMA,STO_CLOSECLOSE,MODE_SIGNAL,1)>80)
                    {
                     //if(iClose(Symbol(),PERIOD_M1,1)<LP(3))

                     //if(Ask>HP(3))
                     //if(maxInd<=2 && minInd>=9 )
                     //if(iAC(NULL,0,0)<iAC(NULL,0,1))
                     if(groupsell && !groupbuy)
                       {
                        lastticket=Trade_Market(OP_SELL,timestamp_sell,init_lot_size,0,0,"ke");
                        return(0);
                       }
                    }
                 }
              }
           }

         //----transition
         if(IsBuy())
           {
            if(ENCisACrime)
              {
               MachineState=state_ecn_buyaddstop;
               Print("ENCisACrime state_ecn_buyaddstop");
              }
            else
              {
               MachineState=state_buy1;
              }
           }
         if(IsSell())
           {
            if(ENCisACrime)
              {
               MachineState=state_ecn_selladdstop;
               Print("ENCisACrime state_ecn_selladdstop");
              }
            else
              {
               MachineState=state_sell1;
              }
           }
         if(IsBuy() && IsSell())
           {
            close_symbol();
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_buyaddstop:
        {
         double tosetstop=0;
         status("state_ecn_buyaddstop");
         if(order_stoploss(get_last_order(MAGIC,OP_BUY))==0)
           {
            MachineState=state_ecn_buyaddtp;
            Print("ENCisACrime state_ecn_buyaddtp");
            return(0);
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_BUY),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),
                                      OrderOpenPrice(),tosetstop,
                                      OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
            Sleep(50);
           }

         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_selladdstop:
        {
         double tosetstop=0;
         status("state_ecn_selladdstop");
         if(order_stoploss(get_last_order(MAGIC,OP_SELL))==0)
           {
            MachineState=state_ecn_selladdtp;
            Print("ENCisACrime state_ecn_selladdtp");

            return(0);
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_SELL),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),tosetstop,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_buyaddtp:
        {
         double tosettakeprofit=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,16,1),Digits);
         if(order_takeprofit(get_last_order(MAGIC,OP_BUY))>0)
           {
            MachineState=state_buy1;
            Print("ENCisACrime state_buy1");

            return(0);
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_BUY),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tosettakeprofit,OrderExpiration(),clrPink);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_selladdtp:
        {
         double tosettakeprofit=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,16,1),Digits);;
         if(order_takeprofit(get_last_order(MAGIC,OP_SELL))>0)
           {
            MachineState=state_sell1;
            Print("ENCisACrime state_sell1");

            return(0);
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_SELL),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tosettakeprofit,OrderExpiration(),clrPink);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_await_buy:
        {
         break;
        }
      case state_await_sell:
        {
         break;
        }
      case state_buy1:
        {
         //----MachineState's action
         //CommonSingleOrderState();
         //stoplosswheelbarrelEXP(lastticket,150*Point,50*Point);

         //---
         if(iCustom(Symbol(),PERIOD_M15,"Quantum",NormalizeDouble(iATR(Symbol(),PERIOD_H4,10,1)*MathPow(10,Digits),Digits),1,0)>0)
           {
            order_close_ALL_SYMBOL();
           }
         //---

         if(pl<=-xpips(ATR) && TimeCurrent()-laststamp>hr_sec(4) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //else if(pl<=-20)
           {

            if(groupsell)
              {
               Remove_StopLoss(lastticket);
               lastticket=Trade_Market(OP_BUY,timestamp_buy,init_lot_size,0,0,"ke,Re");

              }

           }

         if(order_takeprofit(get_last_order(MAGIC,OP_BUY))==0)
           {
            MachineState=state_ecn_buyaddtp;
            return(0);
           }
         //----transition
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         if(IsBuys())
           {
            MachineState=state_buy2;
            calbreak_flag=true;
           }
         break;
        }
      case state_sell1:
        {
         //----MachineState's action
         //CommonSingleOrderState();
         //stoplosswheelbarrelEXP(lastticket,150*Point,50*Point);
         if(iCustom(Symbol(),PERIOD_M15,"Quantum",NormalizeDouble(iATR(Symbol(),PERIOD_H4,10,1)*MathPow(10,Digits),Digits),0,0)>0)
           {
            order_close_ALL_SYMBOL();
           }
         if(pl<=-xpips(ATR) && TimeCurrent()-laststamp>hr_sec(4) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //else if(pl<=-20)
           {

            if(groupbuy)
              {
               Remove_StopLoss(lastticket);
               lastticket=Trade_Market(OP_SELL,timestamp_sell,init_lot_size,0,0,"ke,Re");
              }

           }
         //----transition
         if(order_takeprofit(get_last_order(MAGIC,OP_SELL))==0)
           {
            MachineState=state_ecn_selladdtp;
            return(0);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         if(IsSells())
           {
            MachineState=state_sell2;
            calbreak_flag=true;
           }
         break;
        }
      case state_buy2:
        {
         power=OACount(MAGIC,OP_BUY,Symbol());
         if(checksametp(MAGIC,OP_BUY)==false && calbreak_flag==false)
           {
            calbreak_flag=true;
           }
         //if(calbreak_flag==true)
           {
            lots=init_lot_size*MathPow(exponent,power);
            status("Next Lot Size="+DoubleToStr(lots,2));
            target_gain=squeeze_factor*ATR;
            if(target_gain<30*Point) target_gain=30*Point;
            new_target_price=thisBreakEven+target_gain;

            //enforce if recovery orders are more than xx number, just got all of them close ASAP
            if(power>=4 && power<8) new_target_price=thisBreakEven+0.5*target_gain;
            if(power>=8 ) new_target_price=thisBreakEven+0.1*target_gain;

            ModifyTakeProfit(OP_BUY,new_target_price);
            calbreak_flag=false;

           }

         if(pl<=-xpips(2*ATR) && pl<=-xpips(0.2*dailyATR) && TimeCurrent()-laststamp>hr_sec(10) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //if(pl<=-20)
           {
            if(IsTimeUnlocked_buy())
              {
               if(groupsell)
                 {
                  lastticket=Trade_Market(OP_BUY,timestamp_buy,lots,0,0,"ke,Re");
                  if(OrderSelect(lastticket,SELECT_BY_TICKET)) calbreak_flag=true;
                 }
              }
           }

         //the MachineState is more than 7 hours old

         //----transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         if(IsBuy()) MachineState=state_buy1;
         if(IsSell()) MachineState=state_sell1;

         //Is new bar?

         break;
        }

      case state_sell2:
        {

         power=OACount(MAGIC,OP_SELL,Symbol());
         if(checksametp(MAGIC,OP_SELL)==false && calbreak_flag==false)
           {
            calbreak_flag=true;
           }
         //if(calbreak_flag==true)
           {
            lots=init_lot_size*MathPow(exponent,power);
            status("Next Lot Size="+DoubleToStr(lots,2));
            target_gain=squeeze_factor*ATR;
            if(target_gain<30*Point) target_gain=30*Point;
            new_target_price=thisBreakEven-target_gain;
            //enforce if recovery orders are more than xx number, just got all of them close ASAP
            if(power>=4 && power<8) new_target_price=thisBreakEven-0.5*target_gain;
            if(power>=8) new_target_price=thisBreakEven-0.1*target_gain;


            ModifyTakeProfit(OP_SELL,new_target_price);
            calbreak_flag=false;
            TP_is_too_low=false;
           }

         if(pl<=-xpips(2*ATR) && pl<=-xpips(0.2*dailyATR) && TimeCurrent()-laststamp>hr_sec(10) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //if(pl<=-20)
           {
            if(IsTimeUnlocked_sell())
              {
               if(groupbuy)
                 {
                  lastticket=Trade_Market(OP_SELL,timestamp_sell,lots,0,0,"ke,Re");
                  if(OrderSelect(lastticket,SELECT_BY_TICKET)) calbreak_flag=true;
                 }
              }

           }

         //----transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         if(IsBuy()) MachineState=state_buy1;
         if(IsSell()) MachineState=state_sell1;

         break;
        }
      case state_buy2_hold:
        {
         newMark=LP(2);
         if(iBars(Symbol(),Period())>bbb)
           {
            if(newMark>thisBreakEven)
              {
               ModifyStopLoss(CMD,newMark);
               ModifyTakeProfit(CMD,High[1]+100*Point);
              }
            bbb=iBars(Symbol(),Period());
           }
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }
      case state_sell2_hold:
        {
         newMark=HP(2);
         if(IsNoPosition())
           {
            if(newMark<thisBreakEven)
              {
               ModifyStopLoss(CMD,newMark);
               ModifyTakeProfit(CMD,Low[1]-100*Point);
              }
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }
      case state_revbuy_tradesell:
        {
         //lastticket=Trade_Market(OP_SELL,timestamp_sell,2*init_lot_size,lowerbound,0,"Reverse_buy");
         lastticket=Trade_Market(OP_SELL,timestamp_sell,2*init_lot_size,Ask+0.4*ATR,0,"Reverse_buy");
         Print(IntegerToString(MachineState)+":Reverse Order has been placed, SELL ticket #"+IntegerToString(lastticket));

         //---- transition
         if(IsSell() && IsNoBuy()) MachineState=state_revsell_tradebuy_trail;
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }
      case state_revsell_tradebuy:
        {
         //lastticket=Trade_Market(OP_BUY,timestamp_buy,2*init_lot_size,upperbound,0,"Reverse_trail");
         lastticket=Trade_Market(OP_BUY,timestamp_buy,2*init_lot_size,Bid-0.4*ATR,0,"Reverse_trail");
         Print(IntegerToString(MachineState)+":Reverse Order has been placed, BUY ticket #"+IntegerToString(lastticket));

         //---- transition
         if(IsBuy() && IsNoSell()) MachineState=state_revsell_tradebuy_trail;
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }

      case  state_revbuy_tradesell_trail:
        {

         ftx(lastticket);

         //---- transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }
      case  state_revsell_tradebuy_trail:
        {

         ftx(lastticket);

         //---- transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }
     }
   _tickcount=GetTickCount()-tickcount;
   status("processing time="+DoubleToStr(_tickcount,2)+"ms");
   Comment(comment_string+comments);
//----
   return(0);
  }
//+------------------------------------------------------------------+

int MAGIC_LIST_BY_SYMBOL()
  {
//---
   int _magic;
   if(Symbol()=="GBPUSD")  _magic=100;
   if(Symbol()=="EURUSD")  _magic=110;
   if(Symbol()=="USDCHF")  _magic=120;
   if(Symbol()=="AUDUSD")  _magic=130;
   if(Symbol()=="NZDUSD")  _magic=140;
   if(Symbol()=="USDCAD")  _magic=150;
   if(Symbol()=="USDJPY")  _magic=160;

   if(Symbol()=="GBPAUD")  _magic=200;
   if(Symbol()=="GBPNZD")  _magic=210;
   if(Symbol()=="GBPCAD")  _magic=220;
   if(Symbol()=="GBPCHF")  _magic=230;
   if(Symbol()=="GBPJPY")  _magic=240;
   if(Symbol()=="EURGBP")  _magic=250;

   if(Symbol()=="EURAUD")  _magic=300;
   if(Symbol()=="EURNZD")  _magic=310;
   if(Symbol()=="EURCAD")  _magic=320;
   if(Symbol()=="EURCHF")  _magic=330;
   if(Symbol()=="EURJPY")  _magic=340;


//---   
   return(_magic);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void status(string msg)
  {
   comments=comments+">>"+now+">>"+msg+"\n";
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderAccounting()
  {
   ArrayInitialize(OrderAcc_buy,0);
   ArrayInitialize(OrderAcc_sell,0);
   int countb=0;
   int counts=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if(OrderMagicNumber()==MAGIC)
           {
            if(OrderType()==OP_BUY)
              {
               OrderAcc_buy[countb][0]=OrderTicket();
               OrderAcc_buy[countb][1]=OrderLots();
               OrderAcc_buy[countb][2]=OrderOpenPrice();
               countb++;
              }
            if(OrderType()==OP_SELL)
              {
               OrderAcc_sell[counts][0]=OrderTicket();
               OrderAcc_sell[counts][1]=OrderLots();
               OrderAcc_sell[counts][2]=OrderOpenPrice();
               counts++;
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double BreakEvenPrice2(int side)
  {
   double sumxy;
   double sumy;
   double weightaverage=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderMagicNumber()==MAGIC && OrderSymbol()==Symbol())
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      weightaverage=sumxy/sumy;
     }
   return(weightaverage);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double BreakEvenPrice(int side)
  {
   int size;
   int i;
   double SumLots=0;
   double SumPriceLots=0;
   double breakeven;
   switch(side)
     {
      case OP_BUY:
        {
         size=ArraySize(OrderAcc_buy);
         if(size>0)
           {
            for(i=0;i<size;i++)
              {
               if(OrderAcc_buy[i][0]!=0)
                 {
                  SumLots=SumLots+OrderAcc_buy[i][1];
                  SumPriceLots=SumPriceLots+(OrderAcc_buy[i][1]*OrderAcc_buy[i][2]);
                  if(SumLots>0) breakeven=SumPriceLots/SumLots;
                  else Print("BreakEvenPrice:OP_BUY: error SumLots is zero!");
                 }
              }
           }

         break;
        }
      case OP_SELL:
        {
         size=ArraySize(OrderAcc_sell);
         if(size>0)
           {
            for(i=0;i<size;i++)
              {
               if(OrderAcc_sell[i][0]!=0)
                 {
                  SumLots=SumLots+OrderAcc_sell[i][1];
                  SumPriceLots=SumPriceLots+(OrderAcc_sell[i][1]*OrderAcc_sell[i][2]);
                  if(SumLots>0) breakeven=SumPriceLots/SumLots;
                  else Print("BreakEvenPrice:OP_SELL: error SumLots is zero!");
                 }
              }
           }

         break;
        }
     }
   return(breakeven);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int xpips(double decimal)
  {
   return(decimal*MathPow(10,Digits-1));
  }
//#ft
void ftx(int ticketnumber)
  {
   double quote;
   double distance;
   double master_distance;
   double propose_stop;
   bool  price_ok=true;
   double MarkedDistance;
   double offset1,offset2;
   MarkedDistance=80*Point;
   offset1=30*Point;
   offset2=70*Point;
   if(offset2>=MarkedDistance-30*Point) offset2=30*Point;

   double minstop=MarketInfo(OrderSymbol(),MODE_STOPLEVEL)*Point;
   master_distance=150*Point;
   if(OrderSelect(ticketnumber,SELECT_BY_TICKET)==true && OrderCloseTime()==0)
     {
      if(OrderType()==OP_BUY)
        {
         quote=Bid;
         if(OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice())
           {
            distance=Bid-OrderOpenPrice();
            if(distance>MarkedDistance)
              {
               propose_stop=OrderOpenPrice()+offset1;
              }
           }
         if(OrderStopLoss()>OrderOpenPrice())
           {
            distance=Bid-OrderStopLoss();
            if(distance>MarkedDistance)
              {
               propose_stop=Bid-offset2;
              }
           }
         propose_stop=NormalizeDouble(propose_stop,Digits);
         if(propose_stop!=0 && propose_stop<Bid && (propose_stop<OrderOpenPrice()-minstop || propose_stop>OrderOpenPrice()))
           {
            if(OrderModify(OrderTicket(),OrderOpenPrice(),propose_stop,OrderTakeProfit(),OrderExpiration(),CLR_NONE)==true)
              {
               Print("Modify order stoploss success.");
              }
           }
        }
      else if(OrderType()==OP_SELL)
        {
         quote=Ask;
         if(OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice())
           {
            distance=OrderOpenPrice()-Ask;
            if(distance>MarkedDistance)
              {
               propose_stop=OrderOpenPrice()-offset1;
              }
           }
         if(OrderStopLoss()<OrderOpenPrice())
           {
            distance=OrderStopLoss()-Ask;
            if(distance>MarkedDistance)
              {
               propose_stop=Ask+offset2;
              }
           }
         propose_stop=NormalizeDouble(propose_stop,Digits);
         if(propose_stop!=0 && propose_stop>Ask && (propose_stop>OrderOpenPrice()+minstop || propose_stop<OrderOpenPrice()))
           {

            if(OrderModify(OrderTicket(),OrderOpenPrice(),propose_stop,OrderTakeProfit(),OrderExpiration(),CLR_NONE)==true)
              {
               Print("Modify order stoploss success.");
              }
           }
        }

     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_CurrentRange()
  {
   double RangeHighLow;
   lowerbound =LP(candles_range)-100*Point;
   upperbound =HP(candles_range)+100*Point;
   ATR=iATR(Symbol(),PERIOD_H1,atr_range,1);
   fastATR=iATR(Symbol(),PERIOD_H1,atr_range/2,1);
   dailyATR=iATR(Symbol(),PERIOD_D1,D1_atr_range,1);
   if(ATR<100*Point) ATR=100*Point;

   double trigger_entry_range=HP(5)-LP(5);
   trigger_entry_range=trigger_entry_range*DECPIP;
//double val=iCustom(NULL,0,"Candlestop",5,1,0);
/*
   double array_atr[4];
   array_atr[0]=iATR(Symbol(),0,atr_range,1);
   array_atr[1]=iATR(Symbol(),0,atr_range,2);
   array_atr[2]=iATR(Symbol(),0,atr_range,3);
   array_atr[3]=iATR(Symbol(),0,atr_range,4);
   ATR_Slope=GetSlope(array_atr)*100000;
   */
   RangeHighLow=xpips(HP(candles_range)-LP(candles_range));
   RangeHighLow=RangeHighLow*DECPIP;
   status("candles_range("+candles_range+")="+DoubleToStr(RangeHighLow,0)+units);
   status("TriggerRange="+DoubleToStr(trigger_entry_range,0)+units);
   status("ATR("+atr_range+")="+DoubleToStr(ATR*DECPIP,0)+units);
   status("dailyATR("+D1_atr_range+")="+DoubleToStr(dailyATR*DECPIP,0)+units);
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_LastTicket()
  {
   pl=OAPLPips(lastticket);
   if(OrderSelect(lastticket,SELECT_BY_TICKET)==true)
     {
      ThisOpenPrice=OrderOpenPrice();
     }
   status("Last Ticket="+IntegerToString(lastticket));
   status("Profit/Loss="+DoubleToStr(pl,1)+"pips");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_buy()
  {
   status("Last Time Stamp="+TimeToStr(timestamp_buy,TIME_MINUTES)+", Minutes to unlock time="+MinutesToUnlock_buy+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void createCommentBlockGraphic()
  {
   RectLabelCreate(0,Symbol()+"frame",0,0,0,300,500,clrDarkKhaki,2,CORNER_LEFT_UPPER);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_sell()
  {
   status("Last Time Stamp="+TimeToStr(timestamp_sell,TIME_MINUTES)+", Minutes to unlock time="+MinutesToUnlock_sell+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Remove_StopLoss(int ticketnumber)
  {
//Remove stop loss price first before do martingale to recovery
   status("Remove_StopLoss: Removing stoploss on ticket #"+ticketnumber);
   bool selected=false;
   if(OrderSelect(ticketnumber,SELECT_BY_TICKET))
      selected=true;
   if(OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),OrderExpiration(),Gray)==true && selected)
     {
      Print(IntegerToString(MachineState)+":Remove_StopLoss: Stoploss for order #"+ticketnumber+" is now set to zero");
     }
   else
     {
      Print(IntegerToString(MachineState)+":Error in Remove_StopLoss: Code="+GetLastError());
     }
   return;
  }
// Trade_Market(OP_BUY,0.1,"Main",0,0,timestamp_buy);
int Trade_Market(int side,datetime &_timestamp,double lot_size,double stop_price=0,double target_price=0,string comment="")
  {
   int retTicket=0;
   if(side==OP_BUY)  retTicket=Trade_Buy(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   if(side==OP_SELL)  retTicket=Trade_Sell(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   _timestamp=TimeCurrent();

   if(retTicket>0)
     {
      Print(IntegerToString(MachineState)+":Trade_Market: Placed order successfully, ticket #"+retTicket);
     }
   return(retTicket);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_buy()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+OACount(MAGIC,OP_BUY,Symbol()));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_buy[index][0]!=0)
        {
         status("//----  #"+index+" |"+DoubleToStr(OrderAcc_buy[index][0],0)+", "+DoubleToStr(OrderAcc_buy[index][1],2)+", "+DoubleToStr(OrderAcc_buy[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_BUY);
   if(thisBreakEven-Bid>0)
     {
      distance_Loss=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
      distance_Gain=0;
     }
   else if(thisBreakEven-Bid==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_sell()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+OACount(MAGIC,OP_SELL,Symbol()));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_sell[index][0]!=0)
        {
         status("//----  #"+index+" |"+DoubleToStr(OrderAcc_sell[index][0],0)+", "+DoubleToStr(OrderAcc_sell[index][1],2)+", "+DoubleToStr(OrderAcc_sell[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_SELL);
   if(thisBreakEven-Ask>0)
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
     }
   else if(thisBreakEven-Ask==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {

      distance_Loss=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
      distance_Gain=0;

     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Recovery_Close_All_buy()
  {
   bool close_done=false;
   Print(IntegerToString(MachineState)+":Recovery_Close_All_buy: Commencing closing seqeunce...");
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_buy[index][0]!=0)
        {
         if(OrderSelect(OrderAcc_buy[index][0],SELECT_BY_TICKET)==true)
           {
            status("Selected Order #"+DoubleToStr(OrderAcc_buy[index][0],0)+", OK to close");
            close_done=OrderClose(OrderTicket(),OrderLots(),Bid,5,Salmon);
            while(IsTradeContextBusy())
              {
               status("Trade context is busy... (sleeping zZz)");
               Sleep(20);
              }
            if(close_done==true) Print(IntegerToString(MachineState)+":Recovery_Close_All_buy: ._closed ticket #"+OrderTicket()+", CloseTime="+TimeToStr(OrderCloseTime(),TIME_MINUTES));
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Recovery_Close_All_sell()
  {
   bool close_done=false;
   Print(IntegerToString(MachineState)+":Recovery_Close_All_sell: Commencing closing seqeunce...");
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_sell[index][0]!=0)
        {
         if(OrderSelect(OrderAcc_sell[index][0],SELECT_BY_TICKET)==true)
           {
            status("Selected Order #"+DoubleToStr(OrderAcc_sell[index][0],0)+", OK to close");
            close_done=OrderClose(OrderTicket(),OrderLots(),Ask,5,PaleGreen);
            while(IsTradeContextBusy())
              {
               status("Trade context is busy... (sleeping zZz)");
               Sleep(20);
              }
            if(close_done==true) Print(IntegerToString(MachineState)+":Recovery_Close_All_sell: ._closed ticket #"+OrderTicket()+", CloseTime="+TimeToStr(OrderCloseTime(),TIME_MINUTES));
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTimeUnlocked_buy()
  {
   if(TimeCurrent()>timestamp_buy+HoldMinutes*60 && TimeCurrent()>timestamp_close+HoldMinutes*60)
      return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTimeUnlocked_sell()
  {
   if(TimeCurrent()>timestamp_sell+HoldMinutes*60 && TimeCurrent()>timestamp_close+HoldMinutes*60)
      return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyTakeProfit(int typeorder,double newtakeprofit)
  {
   int ticket;
   bool select_ok=false;
   bool price_ok=true;
   bool mod_ok=false;
   int retError=0;
   for(int i=0;i<25;i++)
     {
      if(typeorder==OP_BUY)
        {
         ticket=OrderAcc_buy[i][0];
        }
      else
      if(typeorder==OP_SELL)
        {
         ticket=OrderAcc_sell[i][0];
        }

      select_ok=OrderSelect(ticket,SELECT_BY_TICKET);

      newtakeprofit=NormalizeDouble(newtakeprofit,MarketInfo(OrderSymbol(),MODE_DIGITS));

      if(MathAbs(newtakeprofit-OrderTakeProfit())<10*Point) price_ok=false;
      if(MathAbs(newtakeprofit-OrderOpenPrice())<10*Point) price_ok=false;
      if(MathAbs(newtakeprofit-OrderStopLoss())<10*Point) price_ok=false;

      if(newtakeprofit==OrderTakeProfit() || newtakeprofit==OrderOpenPrice() || newtakeprofit==OrderStopLoss()) price_ok=false;

      if(ticket>0 && MathAbs(newtakeprofit-OrderTakeProfit())>pips(1) && select_ok && price_ok)
        {
         mod_ok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),newtakeprofit,OrderExpiration(),PaleGreen);
         retError=GetLastError();
         if(retError!=0)
           {
            Print(now+", ModifyTakeProfit(),"+" Fail ModifyOrder() code"+retError);
           }
        }
      while(IsTradeContextBusy())
        {
         Sleep(100);
        }

     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int hr_sec(int hours)
  {
   return(hours*60*60);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyStopLoss(int typeorder,double newstoplosslevel)
  {
   int ticket;
   bool select_ok=false;
   bool price_ok=true;
   bool mod_ok=false;
   int retError=0;
   int STOPLEVEL;
   STOPLEVEL=MarketInfo(OrderSymbol(),MODE_STOPLEVEL);
   for(int i=0;i<25;i++)
     {
      if(typeorder==OP_BUY)
        {
         ticket=OrderAcc_buy[i][0];
        }
      else
      if(typeorder==OP_SELL)
        {
         ticket=OrderAcc_sell[i][0];
        }

      select_ok=OrderSelect(ticket,SELECT_BY_TICKET);

      newstoplosslevel=NormalizeDouble(newstoplosslevel,MarketInfo(OrderSymbol(),MODE_DIGITS));

      if(MathAbs(newstoplosslevel-OrderStopLoss())<10*Point) price_ok=false;
      if(newstoplosslevel==OrderOpenPrice())  price_ok=false;
      if(newstoplosslevel==OrderTakeProfit())  price_ok=false;

      //if(ticket>0 && MathAbs(newtakeprofit-OrderTakeProfit())>pips(1) && select_ok)
      if(
         ticket>0 && select_ok && price_ok
         )
        {
         if(OrderType()==OP_BUY && newstoplosslevel<OrderOpenPrice() && newstoplosslevel>OrderOpenPrice()-STOPLEVEL*Point)
           {
            newstoplosslevel=OrderOpenPrice()+10*Point;
           }
         if(OrderType()==OP_SELL && newstoplosslevel>OrderOpenPrice() && newstoplosslevel<OrderOpenPrice()+STOPLEVEL*Point)
           {
            newstoplosslevel=OrderOpenPrice()-10*Point;
           }

         mod_ok=OrderModify(OrderTicket(),OrderOpenPrice(),newstoplosslevel,OrderTakeProfit(),OrderExpiration(),PaleGreen);
         retError=GetLastError();
         if(retError!=0)
           {
            Print(now+", ModifyStopLoss(),"+" Fail ModifyOrder() code"+retError);
           }
        }
      while(IsTradeContextBusy())
        {
         Sleep(100);
        }

     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RecordMaxGAINLOSS()
  {
   string t;

   if(pl>max_gain && pl>0) max_gain=pl;
   if(pl<max_loss && pl<0) max_loss=pl;

   if(max_loss!=0) RRR=MathAbs(max_gain/max_loss);  else RRR=-1;
   t="RRR"+DoubleToStr(RRR,2)+", MAXG"+DoubleToStr(max_gain,1)+", MAXL"+DoubleToStr(max_loss,1);

   status(t);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderOpenTooLongAndNotMove()
  {
   if(TimeCurrent()-laststamp>hr_sec(2) && TimeCurrent()-laststamp>hr_sec(8) && RRR!=0)
     {
      if(1/RRR>=1.5 && -max_loss>=10 && pl>=5)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,DarkGray)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC1");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+15*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+15*60;
           }
        }
     }

   if(TimeCurrent()-laststamp>hr_sec(3) && RRR!=0)
     {
      if(1/RRR>=5 && -max_loss>=10 && pl>=-20)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Goldenrod)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC2");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+15*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+15*60;
           }
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BuyThenImmediateProfit()
  {
   bool stochOBOS=false;
   double piptotake;
//piptotake=xpips(fastATR);
   piptotake=10;
//if(xpips(fastATR)<=10)   piptotake=5;
   if(TimeCurrent()-laststamp<hr_sec(1))
     {
      if(pl>=piptotake)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Olive)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:BuyThenImmediateProfit()");
            if(MachineState==state_buy1)
              {
               BlockBuyUntilTime=TimeCurrent()+15*60;
               //MachineState=state_revbuy_tradesell;
              }
            if(MachineState==state_sell1)
              {
               BlockSellUntilTime=TimeCurrent()+15*60;
               //MachineState=state_revsell_tradebuy;
              }
           }

        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CummPL()
  {
   string t;
   switch(MachineState)
     {
      case state_buy2:
        {
         cummpl=Bid-thisBreakEven;
         break;
        }
      case state_sell2:
        {
         cummpl=thisBreakEven-Ask;
         break;
        }
     }
   cummpl=cummpl*MathPow(10,Digits-1);
   t="Cumm PL (pips)="+DoubleToStr(cummpl,2);
   status(t);
  }
//#common
void CommonSingleOrderState()
  {
   stoplosswheelbarrel(lastticket,markPts*Point,movePts*Point);
   if(order_period_seconds(lastticket)>60*60)
     {
      if(order_profit_points(lastticket)>10*Point)
        {
         close_order_immediate(lastticket);
        }
     }
   switch(order_type(lastticket))
     {
      case  OP_BUY:
        {
         if(iAC(Symbol(),0,1)<iAC(Symbol(),0,2))
           {
            //stoplosswheelbarrel(lastticket,30*Point,5*Point);
            //close_order_immediate(lastticket);
           }
         break;
        }

      case  OP_SELL:
        {
         if(iAC(Symbol(),0,1)>iAC(Symbol(),0,2))
           {
            //stoplosswheelbarrel(lastticket,30*Point,5*Point);
            //close_order_immediate(lastticket);
           }
         break;
        }
     }
//---
//stoplosswheelbarrel(lastticket,30*Point,5*Point);
//if(order_period_seconds(lastticket)>60*60)
//  {
//   if(order_profit_points(lastticket)>10*Point)
//     {
//      close_order_immediate(lastticket);
//     }
//  }


//---

//if(order_period_seconds(lastticket)>2*60*60&&order_period_seconds(lastticket)<8*60*60)
//  {
//   if(order_loss_point(lastticket)>200*Point)
//     {
//      close_order_immediate(lastticket);
//     }
//  }
   if(iBars(Symbol(),Period())>bbb)
     {
      OrderOpenTooLongAndNotMove();
      BuyThenImmediateProfit();
      //PositionLossAfterHrsthenClose();  
      bbb=iBars(Symbol(),Period());
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderCloseAll(int side)
  {
   int ticket;

   for(int i=0;i<25;i++)
     {
      if(side==OP_BUY)  ticket=OrderAcc_buy[i][0];
      if(side==OP_SELL)  ticket=OrderAcc_sell[i][0];
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
        {
         if(OrderClose(OrderTicket(),OrderLots(),Bid,5,DarkGray)==true)
           {
            Print("close order, ticket#"+OrderTicket()+", REASON:OrderCloseAll()");
           }
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void PositionLossAfterHrsthenClose()
  {
   if(TimeCurrent()-laststamp>hr_sec(1) && TimeCurrent()-laststamp<hr_sec(3))
     {
      if(-max_loss>30 && RRR<0.1 && pl<-10)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,DarkGray)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:PositionLossAfterHrsthenClose()");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+HoldMinutes*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+HoldMinutes*60;
           }
        }
     }
  }
//#runcomment
void Run_Comment()
  {
//----Signal Watchs & Infomartion/Comment
   switch(MachineState)
     {
      case state_idle:
        {
         //----MachineState info
         status("wating for signal...");
         showmycomment_CurrentRange();
         break;
        }
      case state_buy1:
        {
         status(".. trailing stop loss for buy pos");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         RecordMaxGAINLOSS();

         break;
        }
      case state_sell1:
        {
         status(".. trailing stop loss for sell pos");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         RecordMaxGAINLOSS();

         break;
        }
      case state_await_buy:
        {
         status(".. trailing stop loss for buy pos");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case state_await_sell:
        {
         status(".. trailing stop loss for sell pos");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
      case state_buy2:
        {
         status(".. recovery buy mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         showmycomment_ListOrder_buy();
         CummPL();
         break;
        }
      case state_sell2:
        {
         status(".. recovery sell mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         showmycomment_ListOrder_sell();
         CummPL();
         break;
        }
      case state_buy2_hold:
        {
         status(".. recovery buy mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         showmycomment_ListOrder_buy();
         CummPL();
         break;
        }
      case state_sell2_hold:
        {
         status(".. recovery sell mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         showmycomment_ListOrder_sell();
         CummPL();
         break;
        }

      case state_revbuy_tradesell:
        {
         status(".. reversing from buy to sell mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
      case state_revsell_tradebuy:
        {
         status(".. reversing from sell to buy mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case  state_revbuy_tradesell_trail:
        {
         status(".. trailing stop loss for reversed-side order, buy mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case  state_revsell_tradebuy_trail:
        {
         status(".. trailing stop loss for reversed-side order, sell mode");
         showmycomment_CurrentRange();
         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_State_Transition()
  {
   switch(MachineState)
     {
      case state_idle:
        {
         break;
        }
      case state_buy1:
        {
         break;
        }
      case state_sell1:
        {
         break;
        }
      case state_await_buy:
        {
         break;
        }
      case state_await_sell:
        {
         break;
        }
      case state_buy2:
        {
         break;
        }
      case state_sell2:
        {
         break;
        }
      case state_buy2_hold:
        {
         break;
        }
      case state_sell2_hold:
        {
         break;
        }
      case state_revbuy_tradesell:
        {
         break;
        }
      case state_revsell_tradebuy:
        {
         break;
        }
      case state_revbuy_tradesell_trail:
        {
         break;
        }
      case state_revsell_tradebuy_trail:
        {
         break;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_TimeStampControl()
  {
   switch(MachineState)
     {
      case state_idle:                 laststamp=timestamp_close;    break;
      case state_buy1:                 laststamp=timestamp_buy;      break;
      case state_sell1:                laststamp=timestamp_sell;     break;
      case state_await_buy:            laststamp=timestamp_buy;      break;
      case state_await_sell:           laststamp=timestamp_sell;     break;
      case state_buy2:
        {
         laststamp=timestamp_buy;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_buy;
         MultiOrderState_Age=TimeCurrent()-MultiOrderStateTimeStamp;
         break;
        }
      case state_sell2:
        {
         laststamp=timestamp_sell;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_sell;
         MultiOrderState_Age=TimeCurrent()-MultiOrderStateTimeStamp;
         break;
        }
      case state_buy2_hold:
        {
         laststamp=timestamp_buy;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_buy;
         MultiOrderState_Age=TimeCurrent()-MultiOrderStateTimeStamp;
         break;
        }
      case state_sell2_hold:
        {
         laststamp=timestamp_sell;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_sell;
         MultiOrderState_Age=TimeCurrent()-MultiOrderStateTimeStamp;
         break;
        }
      case state_revbuy_tradesell:          laststamp=timestamp_buy;      break;
      case state_revsell_tradebuy:         laststamp=timestamp_sell;     break;
      case state_revbuy_tradesell_trail:    laststamp=timestamp_buy;      break;
      case state_revsell_tradebuy_trail:   laststamp=timestamp_sell;     break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_CurrentStateShortCode()
  {
   switch(MachineState)
     {
      case state_idle:                 now="I";    break;
      case state_ecn_buyaddstop:                 now="BSL";    break;
      case state_ecn_buyaddtp:                 now="BTP";    break;
      case state_ecn_selladdstop:                 now="SSL";    break;
      case state_ecn_selladdtp:                 now="STP";    break;
      case state_buy1:                 now="B1";    break;
      case state_sell1:                now="S1";    break;
      case state_await_buy:            now="B0";    break;
      case state_await_sell:            now="S0";    break;
      case state_buy2:                 now="B2";    break;
      case state_sell2:                now="S2";    break;
      case state_buy2_hold:                 now="B2H";    break;
      case state_sell2_hold:                now="S2H";    break;
      case state_revbuy_tradesell:          now="RB";      break;
      case state_revsell_tradebuy:         now="RS";      break;
      case state_revbuy_tradesell_trail:    now="RBT";   break;
      case state_revsell_tradebuy_trail:   now="RST";   break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_OrderCommand()
  {
   switch(MachineState)
     {
      case state_idle:                 CMD=-1;    break;
      case state_buy1:                 CMD=OP_BUY;    break;
      case state_sell1:                CMD=OP_SELL;    break;
      case state_await_buy:            CMD=OP_BUY;    break;
      case state_await_sell:           CMD=OP_SELL;    break;
      case state_buy2:                 CMD=OP_BUY;    break;
      case state_sell2:                CMD=OP_SELL;    break;
      case state_buy2_hold:                 CMD=OP_BUY;    break;
      case state_sell2_hold:                CMD=OP_SELL;    break;
      case state_revbuy_tradesell:         CMD=OP_SELL;    break;
      case state_revsell_tradebuy:         CMD=OP_BUY;    break;
      case state_revbuy_tradesell_trail:   CMD=OP_SELL;    break;
      case state_revsell_tradebuy_trail:   CMD=OP_BUY;    break;
     }
  }
//+------------------------------------------------------------------+
bool checksametp(int mn,int side)
  {
   bool retval=true;
   double tp=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==mn && OrderSymbol()==Symbol() && OrderType()==side)
           {
            if(tp==0)
              {
               tp=OrderTakeProfit();
               break;
              }
            if(tp!=0 && tp!=OrderTakeProfit())
              {
               retval=false;
              }
           }
        }
     }
   return(retval);
  }
//+------------------------------------------------------------------+
