//+------------------------------------------------------------------+
//|                                                        Feb10.mq4 |
//|                                             Komgrit Sungkhaphong |
//|                               http://iamforextrader.blogspot.com |
//+------------------------------------------------------------------+

//version50
// -allow user to run multiple instance of bot for the same pair, by specifying the MAGIC number

//version60
// -reduce chan

//v66ba
//-make it compatible to mt4 build 6XX
//-4-digit broker compatible

#property copyright "Komgrit Sungkhaphong"
#property link      "http://iamforextrader.blogspot.com"
/*
#include "libraries\Trade.mq4"
#include "libraries\OAmq4"
#include "libraries\Lib.mq4"
*/
#include <LastOrder.mqh>
#include<Trade.mq4>
#include <OA.mq4>
//#include "Lib.mq4"

#include <EAHeader.mqh>

#define currentversion "80A"
#define version_unique_id  11;
input bool ENCisACrime=true;
#define state_idle         0
#define state_await_buy    500
#define state_await_sell    600
#define state_ecn_buyaddtp    700
#define state_ecn_buyaddstop  750
#define state_ecn_selladdtp    800
#define state_ecn_selladdstop  850
#define state_buy1          1000
#define state_sell1         2000
#define state_buy2          1800
#define state_sell2         2800

#define state_buy2_hold     1900
#define state_sell2_hold    2900

#define state_revbuy_tradesell  1500
#define state_revsell_tradebuy  2500

#define state_revbuy_tradesell_trail  1599
#define state_revsell_tradebuy_trail  2599


//+------------------------------------------------------------------+
//| User Define variables                                   |
//+-----------------------------------------------------------------+
input bool UseAutoID=true;
input int User_define_Bot_ID=12346357;
input int UserDefine_SpreadTooHigh=500;   //Points
input double init_lot_size=0.01;
double execute_lot_size;
double selecting_lot_size;
input double exponent=1.44;
input double squeeze_factor=0.3;

input int atr_range=24;
input int candles_range=12;
input int Calm_candles=8;
input string Calm_range_info="unit in point";
input int Calm_range=200;

//input int D1_Candles=5;
input int D1_atr_range=10;

input double HoldMinutes=60;
input int  High_Or_Low_Diff=40;

input double ShutDownPercent=5.00;

int atr_period=60;
input int mindistanceRecov=200;//For ke,Re order 1 & 2, minimum distance

double maxPrice,minPrice;
int minInd,maxInd;
double multk[11];
//+------------------------------------------------------------------+
//| Order Issue Interlocking                                                 |
//+------------------------------------------------------------------+
double __MIN_LOT_SIZE;
datetime timestamp_buy;
datetime timestamp_sell;
datetime timestamp_close;
int MinutesToUnlock_buy;
int MinutesToUnlock_sell;
//+------------------------------------------------------------------+
//| Multiple Orders Control                                                 |
//+------------------------------------------------------------------+
//    [0][]=ticket number
//    [1][]=lots
//    [2][]=price
double OrderAcc_buy[25][3];
double OrderAcc_sell[25][3];
int lastticket;
double pl;              //pips
double cummpl;
double thisBreakEven;   //price
double distance_Loss;   //pips
double distance_Gain;   //pips
double lots;
double propose_new_stoploss;
double expect_stoploss;
double target_gain;
double new_target_price;
double new_stop_loss;
bool calbreak_flag;
bool TP_is_too_low=false;

double max_gain;
double max_loss;
double estimate_max_loss;
double RRR;
int bbb; //bar count in Isnewbar
datetime laststamp;
datetime BlockBuyUntilTime;
datetime BlockSellUntilTime;
datetime MultiOrderStateTimeStamp;
datetime MultiOrderStateTimeStamp_buy;
datetime MultiOrderStateTimeStamp_sell;
int      MultiOrderState_Age;
double ThisOpenPrice;
double PercentileSafetyLevel;
int CMD;
double newMark;
//+------------------------------------------------------------------+
//| State machine variables                                                  |
//+------------------------------------------------------------------+
int MachineState;
string now;
double tickcount,_tickcount;
//+------------------------------------------------------------------+
//| General variables                                                  |
//+------------------------------------------------------------------+
static int MAGIC;
string comment_string;
string comments;
int RetError;
double SPREAD;
double X45;
string units;
double DECPIP;
string BROKER45;
//+------------------------------------------------------------------+
//| Indicators                                                 |
//+------------------------------------------------------------------+
double ATR;
double fastATR;
double ATR_Slope;
double dailyATR;
double lowerbound;
double upperbound;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----
   __MIN_LOT_SIZE=SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);

//--- enable object create events 
   ChartSetInteger(ChartID(),CHART_EVENT_OBJECT_CREATE,true);
//--- enable object delete events 
   ChartSetInteger(ChartID(),CHART_EVENT_OBJECT_DELETE,true);
   ButtonCreate(ChartID(),"lotPlus1",0,200,15,100,30,0,"+ x1","Courier New",10);
   ButtonCreate(ChartID(),"lotMinus1",0,350,15,100,30,0,"- x1","Courier New",10);
   ButtonCreate(ChartID(),"lotPlus10",0,200,45,100,30,0,"+ x10","Courier New",10);
   ButtonCreate(ChartID(),"lotMinus10",0,350,45,100,30,0,"- x10","Courier New",10);
   ButtonCreate(ChartID(),"lotCF",     0,275,75,100,30,0,">CF<","Courier New",10,clrRed);
   ButtonCreate(ChartID(),"PurgeButton",0,250,155,100,30,0,"PURGE","Courier New",10,clrBlue);
   if(UseAutoID==true)
     {
      MAGIC=AutomaticIDGenerate();
      MAGIC=MAGIC+version_unique_id;
     }
   else
     {
      MAGIC=User_define_Bot_ID;
     }

   execute_lot_size=init_lot_size;
   selecting_lot_size=init_lot_size;
   LabelCreateSimple("executelottext",50,50,text_lotsize(),clrYellow);

   createCommentBlockGraphic();
   if(IsDemo()) comment_string="DEMO"+"\n";
   else comment_string="LIVE"+"\n";
   comment_string=comment_string+"Magic Number="+IntegerToString(MAGIC)+"\n";
//----  Account detail

   comment_string=comment_string;
   Comment(comment_string);

//---- init the MachineState
   MachineState=state_idle;

   int livebuy=order_count_live_type2(MAGIC,OP_BUY);
   int livesell=order_count_live_type2(MAGIC,OP_SELL);

   if(livebuy==1 && livesell==0)
     {
      MachineState=state_buy1;
     }
   if(livebuy==0 && livesell==1)
     {
      MachineState=state_sell1;
     }
   if(livebuy>=2 && livesell==0)
     {
      MachineState=state_buy2;
     }
   if(livebuy==0 && livesell>=2)
     {
      MachineState=state_sell2;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   ObjectsDeleteAll();
//----
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam=="lotPlus1") selecting_lot_size=selecting_lot_size+__MIN_LOT_SIZE;
      if(sparam=="lotMinus1")selecting_lot_size=selecting_lot_size-__MIN_LOT_SIZE;
      if(sparam=="lotPlus10") selecting_lot_size=selecting_lot_size+10*__MIN_LOT_SIZE;
      if(sparam=="lotMinus10")selecting_lot_size=selecting_lot_size-10*__MIN_LOT_SIZE;

      if(sparam=="lotCF")execute_lot_size=selecting_lot_size;
      if(selecting_lot_size<__MIN_LOT_SIZE)
        {
         selecting_lot_size=__MIN_LOT_SIZE;
        }
      LabelTextChange(0,"executelottext",text_lotsize());

      if(sparam=="PurgeButton")
        {
         MachineState=999;
         Print("  Machinestate   =  999 --> PURGING");
        }
     }
  }
//+--
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
  {
//----
   RefreshRates();

//v66ba
   SPREAD=Ask-Bid;
//SPREAD=SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
//status("You are running "+BROKER45);

   int power;
//---

//----Info
   comments="";
   tickcount=GetTickCount();
   double pAccLoss=(AccountEquity()-AccountBalance())/AccountBalance()*100;
   status("%loss="+DoubleToString(pAccLoss,2)+"%");
   lastticket=get_last_order(lastticket);
   if(pAccLoss<-ShutDownPercent)
     {
      //close_symbol();
     }
//----Graphics

   lastticket=get_last_order(MAGIC);

//#statenamecode #stateshort #abbr
   Run_CurrentStateShortCode();
//set tate order command for new order either OP_BUY or OP_SELL
//#ordercommand
   Run_OrderCommand();
//#statetransition #transition
   Run_State_Transition();
//#timestampcontrol
   Run_TimeStampControl();
//Comment message generating sections
//#commentary #commentmessage
   Run_Comment();
//----Actions State Machine
   bool newbarm15=false;
   if(iBars(Symbol(),PERIOD_M15)>barm15)
     {
      newbarm15=true;
      barm15=iBars(Symbol(),PERIOD_M15);
     }
   bool newbarm1=false;
   if(iBars(Symbol(),PERIOD_M1)>barm1)
     {
      newbarm1=true;
      barm1=iBars(Symbol(),PERIOD_M15);
     }
//---

   if(newbarm1)
     {

      maxPrice=-1;
      minPrice=100000;
      //searching for swing
      int r=20;

      double averagemove=0;
      for(int i=0;i<r;i++)
        {
         double high=iHigh(Symbol(),PERIOD_M1,i);
         double low=iLow(Symbol(),PERIOD_M1,i);
         double close=iOpen(Symbol(),PERIOD_M1,i);
         if(high>maxPrice)
           {
            maxPrice=high;
            maxInd=i;
           }
         if(low<minPrice)
           {
            minPrice=low;
            minInd=i;
           }
         //averagemove=averagemove+MathAbs(high-low);
        }
     }
//averagemove=averagemove/r;

   status("maxInd="+IntegerToString(maxInd)+" "+"minInd="+IntegerToString(minInd));
   static bool groupbuy;
   static bool groupsell;
   if(newbarm15)
     {
      groupbuy=false;
      groupsell=false;

      int c=0,d=0;
      for(int i=0;i<32;i++)
        {
         if(iCustom(Symbol(),PERIOD_M15,"Quantum",15,1,i+1)>0)
           {
            c++;
           }
         if(iCustom(Symbol(),PERIOD_M15,"Quantum",15,0,i+1)>0)
           {
            d++;
           }
        }
      if(c>=5)
        {
         groupbuy=true;
        }
      if(d>=5)
        {
         groupsell=true;
        }
     }
//---
   UpdateStateNumber();
   switch(MachineState)
     {
      case state_idle:
        {
         //----State's action
         //create range upper and lower bounds
         max_gain=0;
         max_loss=0;

         //#spreadlock
         //if spread is more than 60, this bot would do nothing. 
         if(SPREAD>UserDefine_SpreadTooHigh*Point)
           {
            //v66ba

            Comment("Point="+DoubleToStr(Point,Digits)+" Spread is too high ="+DoubleToString(SPREAD,Digits)+" (limit="+DoubleToStr(UserDefine_SpreadTooHigh*Point,Digits)+")");
            return;
           }
         //#entry #entries
         static double prevbarsize;
         if(newbarm15) prevbarsize=High[1]-Low[1];
         static double atr14;
         if(newbarm15) atr14=iATR(Symbol(),0,14,0);
         if(IsNoPosition() && TimeCurrent()>timestamp_close+HoldMinutes*60)
           {
            //-----trigger trade buy
            //if(CandleRange(5)>Calm_range*Point)
              {
               expect_stoploss=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               double expect_target=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               if(TimeCurrent()>BlockBuyUntilTime)
                 {
                  PercentileSafetyLevel=PercentileSafetyLevel(OP_BUY,24);
                  //if(PercentileSafetyLevel<30)
                  //if()
                  //if(iStochastic(Symbol(),0,5,3,3,MODE_EMA,STO_CLOSECLOSE,MODE_SIGNAL,1)<20)
                    {
                     //if(iClose(Symbol(),PERIOD_M1,1)>HP(3))

                     //if(Bid<LP(3))
                     //if( minInd<=2 && maxInd>=9)
                     //if(iAC(NULL,0,0)>iAC(NULL,0,1))
                     if(groupbuy && !groupsell)
                       {
                        lastticket=Trade_Market(OP_BUY,timestamp_buy,execute_lot_size,0,0,"ke");
                        return;
                       }
                    }
                 }
              }
            //-----trigger trade sell
            //if(CandleRange(5)>Calm_range*Point)
              {
               expect_stoploss=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);
               double expect_target=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,10,1),Digits);

               if(TimeCurrent()>BlockSellUntilTime)
                 {
                  PercentileSafetyLevel=PercentileSafetyLevel(OP_SELL,24);
                  //if(PercentileSafetyLevel<30)
                  //if(iStochastic(Symbol(),0,5,3,3,MODE_EMA,STO_CLOSECLOSE,MODE_SIGNAL,1)>80)
                    {
                     //if(iClose(Symbol(),PERIOD_M1,1)<LP(3))

                     //if(Ask>HP(3))
                     //if(maxInd<=2 && minInd>=9 )
                     //if(iAC(NULL,0,0)<iAC(NULL,0,1))
                     if(groupsell && !groupbuy)
                       {
                        lastticket=Trade_Market(OP_SELL,timestamp_sell,execute_lot_size,0,0,"ke");
                        return;
                       }
                    }
                 }
              }
           }

         //----transition
         if(IsBuy())
           {
            if(ENCisACrime)
              {
               MachineState=state_ecn_buyaddstop;
               Print("ENCisACrime state_ecn_buyaddstop");
              }
            else
              {
               MachineState=state_buy1;
              }
           }
         if(IsSell())
           {
            if(ENCisACrime)
              {
               MachineState=state_ecn_selladdstop;
               Print("ENCisACrime state_ecn_selladdstop");
              }
            else
              {
               MachineState=state_sell1;
              }
           }
         if(IsBuy() && IsSell())
           {
            close_symbol();
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_buyaddstop:
        {
         double tosetstop=0;
         status("state_ecn_buyaddstop");
         if(order_stoploss(get_last_order(MAGIC,OP_BUY))==0)
           {
            MachineState=state_ecn_buyaddtp;
            Print("ENCisACrime state_ecn_buyaddtp");
            return;
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_BUY),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),
                                      OrderOpenPrice(),tosetstop,
                                      OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
            Sleep(50);
           }

         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_selladdstop:
        {
         double tosetstop=0;
         status("state_ecn_selladdstop");
         if(order_stoploss(get_last_order(MAGIC,OP_SELL))==0)
           {
            MachineState=state_ecn_selladdtp;
            Print("ENCisACrime state_ecn_selladdtp");

            return;
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_SELL),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),tosetstop,OrderTakeProfit(),OrderExpiration(),clrYellow);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_buyaddtp:
        {
         double tosettakeprofit=NormalizeDouble(Ask+1.5*iATR(Symbol(),PERIOD_H4,16,1),Digits);
         if(order_takeprofit(get_last_order(MAGIC,OP_BUY))>0)
           {
            MachineState=state_buy1;
            Print("ENCisACrime state_buy1");

            return;
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_BUY),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tosettakeprofit,OrderExpiration(),clrPink);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_ecn_selladdtp:
        {
         double tosettakeprofit=NormalizeDouble(Bid-1.5*iATR(Symbol(),PERIOD_H4,16,1),Digits);;
         if(order_takeprofit(get_last_order(MAGIC,OP_SELL))>0)
           {
            MachineState=state_sell1;
            Print("ENCisACrime state_sell1");

            return;
           }
         else
           {
            if(OrderSelect(get_last_order(MAGIC,OP_SELL),SELECT_BY_TICKET))
              {
               bool modok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tosettakeprofit,OrderExpiration(),clrPink);
              }
            Sleep(50);
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         break;
        }
      case state_await_buy:
        {
         break;
        }
      case state_await_sell:
        {
         break;
        }
      case state_buy1:
        {
         //----MachineState's action
         //CommonSingleOrderState();
         //stoplosswheelbarrelEXP(lastticket,150*Point,50*Point);
         static double q=0;
         if(newbarm15)
           {
            q=iCustom(Symbol(),PERIOD_M15,"Quantum",NormalizeDouble(iATR(Symbol(),PERIOD_H4,10,1)*MathPow(10,Digits),Digits),1,0);
           }
         //---
         if(q>0)
           {
            order_close_ALL_SYMBOL();
           }
         //---

         if(pl<=-xpips(ATR) && TimeCurrent()-laststamp>hr_sec(4) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //else if(pl<=-20)
           {

            if(groupsell)
              {
               Remove_StopLoss(lastticket);
               lastticket=Trade_Market(OP_BUY,timestamp_buy,execute_lot_size,0,0,"ke,Re");

              }

           }

         if(order_takeprofit(get_last_order(MAGIC,OP_BUY))==0)
           {
            MachineState=state_ecn_buyaddtp;
            return;
           }
         //----transition
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         if(IsBuys())
           {
            MachineState=state_buy2;
            calbreak_flag=true;
           }
         break;
        }
      case state_sell1:
        {
         //----MachineState's action
         //CommonSingleOrderState();
         //stoplosswheelbarrelEXP(lastticket,150*Point,50*Point);
         static double q=0;
         if(newbarm15)
           {
            q=iCustom(Symbol(),PERIOD_M15,"Quantum",NormalizeDouble(iATR(Symbol(),PERIOD_H4,10,1)*MathPow(10,Digits),Digits),0,0);
           }

         if(q>0)
           {
            order_close_ALL_SYMBOL();
           }
         if(pl<=-xpips(ATR) && TimeCurrent()-laststamp>hr_sec(4) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //else if(pl<=-20)
           {

            if(groupbuy)
              {
               Remove_StopLoss(lastticket);
               lastticket=Trade_Market(OP_SELL,timestamp_sell,execute_lot_size,0,0,"ke,Re");
              }

           }
         //----transition
         if(order_takeprofit(get_last_order(MAGIC,OP_SELL))==0)
           {
            MachineState=state_ecn_selladdtp;
            return;
           }
         if(IsNoPosition())
           {
            MachineState=state_idle;
            timestamp_close=TimeCurrent();
           }
         if(IsSells())
           {
            MachineState=state_sell2;
            calbreak_flag=true;
           }
         break;
        }
      case state_buy2:
        {
         power=OACount(MAGIC,OP_BUY,Symbol());
         if(checksametp(MAGIC,OP_BUY)==false && calbreak_flag==false)
           {
            calbreak_flag=true;
           }
         //if(calbreak_flag==true)
           {
            lots=execute_lot_size*MathPow(exponent,power);
            status("Next Lot Size="+DoubleToStr(lots,2));
            target_gain=squeeze_factor*ATR;
            if(target_gain<30*Point) target_gain=30*Point;
            new_target_price=thisBreakEven+target_gain;

            //enforce if recovery orders are more than xx number, just got all of them close ASAP
            if(power>=4 && power<8) new_target_price=thisBreakEven+0.5*target_gain;
            if(power>=8 ) new_target_price=thisBreakEven+0.1*target_gain;

            ModifyTakeProfit(OP_BUY,new_target_price);
            calbreak_flag=false;

           }

         if(pl<=-xpips(2*ATR) && pl<=-xpips(0.2*dailyATR) && TimeCurrent()-laststamp>hr_sec(10) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //if(pl<=-20)
           {
            if(IsTimeUnlocked_buy())
              {
               if(groupsell)
                 {
                  lastticket=Trade_Market(OP_BUY,timestamp_buy,lots,0,0,"ke,Re");
                  if(OrderSelect(lastticket,SELECT_BY_TICKET)) calbreak_flag=true;
                 }
              }
           }

         //the MachineState is more than 7 hours old

         //----transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         if(IsBuy()) MachineState=state_buy1;
         if(IsSell()) MachineState=state_sell1;

         //Is new bar?

         break;
        }

      case state_sell2:
        {

         power=OACount(MAGIC,OP_SELL,Symbol());
         if(checksametp(MAGIC,OP_SELL)==false && calbreak_flag==false)
           {
            calbreak_flag=true;
           }
         //if(calbreak_flag==true)
           {
            lots=execute_lot_size*MathPow(exponent,power);
            status("Next Lot Size="+DoubleToStr(lots,2));
            target_gain=squeeze_factor*ATR;
            if(target_gain<30*Point) target_gain=30*Point;
            new_target_price=thisBreakEven-target_gain;
            //enforce if recovery orders are more than xx number, just got all of them close ASAP
            if(power>=4 && power<8) new_target_price=thisBreakEven-0.5*target_gain;
            if(power>=8) new_target_price=thisBreakEven-0.1*target_gain;


            ModifyTakeProfit(OP_SELL,new_target_price);
            calbreak_flag=false;
            TP_is_too_low=false;
           }

         if(pl<=-xpips(2*ATR) && pl<=-xpips(0.2*dailyATR) && TimeCurrent()-laststamp>hr_sec(10) && pl<=-xpips(mindistanceRecov*multk[power]*Point))
            //if(pl<=-20)
           {
            if(IsTimeUnlocked_sell())
              {
               if(groupbuy)
                 {
                  lastticket=Trade_Market(OP_SELL,timestamp_sell,lots,0,0,"ke,Re");
                  if(OrderSelect(lastticket,SELECT_BY_TICKET)) calbreak_flag=true;
                 }
              }

           }

         //----transition
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         if(IsBuy()) MachineState=state_buy1;
         if(IsSell()) MachineState=state_sell1;

         break;
        }
      case 999:
        {
         close_magic(MAGIC);
         if(IsNoPosition())
           {
            timestamp_close=TimeCurrent();
            MachineState=state_idle;
           }
         break;
        }

     }
   _tickcount=GetTickCount()-tickcount;
   status("processing time="+DoubleToStr(_tickcount,2)+"ms");
   Comment(comment_string+comments);
//----
   return;
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void status(string msg)
  {
   comments=comments+">>"+now+">>"+msg+"\n";
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderAccounting()
  {
   ArrayInitialize(OrderAcc_buy,0);
   ArrayInitialize(OrderAcc_sell,0);
   int countb=0;
   int counts=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
        {
         if(OrderMagicNumber()==MAGIC)
           {
            if(OrderType()==OP_BUY)
              {
               OrderAcc_buy[countb][0]=OrderTicket();
               OrderAcc_buy[countb][1]=OrderLots();
               OrderAcc_buy[countb][2]=OrderOpenPrice();
               countb++;
              }
            if(OrderType()==OP_SELL)
              {
               OrderAcc_sell[counts][0]=OrderTicket();
               OrderAcc_sell[counts][1]=OrderLots();
               OrderAcc_sell[counts][2]=OrderOpenPrice();
               counts++;
              }
           }
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double BreakEvenPrice2(int side)
  {
   double sumxy=0;
   double sumy=0;
   double weightaverage=-1;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderType()==side && OrderMagicNumber()==MAGIC && OrderSymbol()==Symbol())
           {
            sumxy=sumxy+(OrderOpenPrice()*OrderLots());
            sumy=sumy+OrderLots();
           }
        }
     }

   if(sumy>0)
     {
      weightaverage=sumxy/sumy;
     }
   return(weightaverage);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double xpips(double decimal)
  {
   return(decimal*MathPow(10,Digits-1));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_LastTicket()
  {
   pl=OAPLPips(lastticket);
   if(OrderSelect(lastticket,SELECT_BY_TICKET)==true)
     {
      ThisOpenPrice=OrderOpenPrice();
     }
   status("Last Ticket="+IntegerToString(lastticket));
   status("Profit/Loss="+DoubleToStr(pl,1)+"pips");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_buy()
  {
//status("Last Time Stamp="+TimeToStr(timestamp_buy,TIME_MINUTES)+", Minutes to unlock time="+MinutesToUnlock_buy+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void createCommentBlockGraphic()
  {
   RectLabelCreate(0,Symbol()+"frame",0,0,0,200,400,clrDarkBlue,2,CORNER_LEFT_UPPER);
   LabelCreateSimple("statestext",50,15,"STATE="+IntegerToString(state),clrYellow);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_timeunlocked_sell()
  {
//status("Last Time Stamp="+TimeToStr(timestamp_sell,TIME_MINUTES)+", Minutes to unlock time="+MinutesToUnlock_sell+" mins");
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Remove_StopLoss(int ticketnumber)
  {
//Remove stop loss price first before do martingale to recovery
//status("Remove_StopLoss: Removing stoploss on ticket #"+ticketnumber);
   bool selected=false;
   if(OrderSelect(ticketnumber,SELECT_BY_TICKET))
      selected=true;
   if(OrderModify(OrderTicket(),OrderOpenPrice(),0,OrderTakeProfit(),OrderExpiration(),Gray)==true && selected)
     {
      //Print(IntegerToString(MachineState)+":Remove_StopLoss: Stoploss for order #"+ticketnumber+" is now set to zero");
     }
   else
     {
      //Print(IntegerToString(MachineState)+":Error in Remove_StopLoss: Code="+GetLastError());
     }
   return;
  }
// Trade_Market(OP_BUY,0.1,"Main",0,0,timestamp_buy);
int Trade_Market(int side,datetime &_timestamp,double lot_size,double stop_price=0,double target_price=0,string comment="")
  {
   int retTicket=0;
   if(side==OP_BUY)  retTicket=Trade_Buy(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   if(side==OP_SELL)  retTicket=Trade_Sell(Symbol(),MAGIC,lot_size,stop_price,target_price,comment);
   _timestamp=TimeCurrent();

   if(retTicket>0)
     {
      //Print(IntegerToString(MachineState)+":Trade_Market: Placed order successfully, ticket #"+retTicket);
     }
   return(retTicket);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_buy()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+IntegerToString(OACount(MAGIC,OP_BUY,Symbol())));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_buy[index][0]!=0)
        {
         status("//----  #"+IntegerToString(index)+" |"+DoubleToStr(OrderAcc_buy[index][0],0)+", "+DoubleToStr(OrderAcc_buy[index][1],2)+", "+DoubleToStr(OrderAcc_buy[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_BUY);
   if(thisBreakEven-Bid>0)
     {
      distance_Loss=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
      distance_Gain=0;
     }
   else if(thisBreakEven-Bid==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Bid)*MathPow(10,Digits-1);
     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void showmycomment_ListOrder_sell()
  {
   status("//------------Order List (Ticket, Lots, Price) -----------------//");
   status("// ke,Re orders count="+IntegerToString(OACount(MAGIC,OP_SELL,Symbol())));
//----MachineState's action
   OrderAccounting();
   for(int index=0;index<25;index++)
     {
      if(OrderAcc_sell[index][0]!=0)
        {
         status("//----  #"+IntegerToString(index)+" |"+DoubleToStr(OrderAcc_sell[index][0],0)+", "+DoubleToStr(OrderAcc_sell[index][1],2)+", "+DoubleToStr(OrderAcc_sell[index][2],Digits)+"  ----//");
        }
     }
   thisBreakEven=BreakEvenPrice2(OP_SELL);
   if(thisBreakEven-Ask>0)
     {
      distance_Loss=0;
      distance_Gain=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
     }
   else if(thisBreakEven-Ask==0)
     {
      distance_Loss=0;
      distance_Gain=0;
     }
   else
     {

      distance_Loss=MathAbs(thisBreakEven-Ask)*MathPow(10,Digits-1);
      distance_Gain=0;

     }

   status("Current breakeven price="+DoubleToStr(thisBreakEven,Digits));
   status("Distance to breakeven Loss/Gain="+DoubleToStr(distance_Loss,1)+", "+DoubleToStr(distance_Gain,1));
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTimeUnlocked_buy()
  {
   if(TimeCurrent()>timestamp_buy+HoldMinutes*60 && TimeCurrent()>timestamp_close+HoldMinutes*60)
      return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTimeUnlocked_sell()
  {
   if(TimeCurrent()>timestamp_sell+HoldMinutes*60 && TimeCurrent()>timestamp_close+HoldMinutes*60)
      return(true);
   else return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyTakeProfit(int typeorder,double newtakeprofit)
  {
   int ticket=0;
   bool select_ok=false;
   bool price_ok=true;
   bool mod_ok=false;
   int retError=0;
   for(int i=0;i<25;i++)
     {
      if(typeorder==OP_BUY)
        {
         ticket=(int)OrderAcc_buy[i][0];
        }
      else
      if(typeorder==OP_SELL)
        {
         ticket=(int)OrderAcc_sell[i][0];
        }

      select_ok=OrderSelect(ticket,SELECT_BY_TICKET);

      newtakeprofit=NormalizeDouble(newtakeprofit,(int)MarketInfo(OrderSymbol(),MODE_DIGITS));

      if(MathAbs(newtakeprofit-OrderTakeProfit())<10*Point) price_ok=false;
      if(MathAbs(newtakeprofit-OrderOpenPrice())<10*Point) price_ok=false;
      if(MathAbs(newtakeprofit-OrderStopLoss())<10*Point) price_ok=false;

      if(newtakeprofit==OrderTakeProfit() || newtakeprofit==OrderOpenPrice() || newtakeprofit==OrderStopLoss()) price_ok=false;

      if(ticket>0 && MathAbs(newtakeprofit-OrderTakeProfit())>pips(1) && select_ok && price_ok)
        {
         mod_ok=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),newtakeprofit,OrderExpiration(),PaleGreen);
         retError=GetLastError();
         if(retError!=0)
           {
            //Print(now+", ModifyTakeProfit(),"+" Fail ModifyOrder() code"+retError);
           }
        }
      while(IsTradeContextBusy())
        {
         Sleep(100);
        }

     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int hr_sec(int hours)
  {
   return(hours*60*60);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyStopLoss(int typeorder,double newstoplosslevel)
  {
   int ticket=0;
   bool select_ok=false;
   bool price_ok=true;
   bool mod_ok=false;
   int retError=0;
   int STOPLEVEL;
   STOPLEVEL=(int)MarketInfo(OrderSymbol(),MODE_STOPLEVEL);
   for(int i=0;i<25;i++)
     {
      if(typeorder==OP_BUY)
        {
         ticket=(int)OrderAcc_buy[i][0];
        }
      else
      if(typeorder==OP_SELL)
        {
         ticket=(int)OrderAcc_sell[i][0];
        }

      select_ok=OrderSelect(ticket,SELECT_BY_TICKET);

      newstoplosslevel=NormalizeDouble(newstoplosslevel,(int)MarketInfo(OrderSymbol(),MODE_DIGITS));

      if(MathAbs(newstoplosslevel-OrderStopLoss())<10*Point) price_ok=false;
      if(newstoplosslevel==OrderOpenPrice())  price_ok=false;
      if(newstoplosslevel==OrderTakeProfit())  price_ok=false;

      //if(ticket>0 && MathAbs(newtakeprofit-OrderTakeProfit())>pips(1) && select_ok)
      if(
         ticket>0 && select_ok && price_ok
         )
        {
         if(OrderType()==OP_BUY && newstoplosslevel<OrderOpenPrice() && newstoplosslevel>OrderOpenPrice()-STOPLEVEL*Point)
           {
            newstoplosslevel=OrderOpenPrice()+10*Point;
           }
         if(OrderType()==OP_SELL && newstoplosslevel>OrderOpenPrice() && newstoplosslevel<OrderOpenPrice()+STOPLEVEL*Point)
           {
            newstoplosslevel=OrderOpenPrice()-10*Point;
           }

         mod_ok=OrderModify(OrderTicket(),OrderOpenPrice(),newstoplosslevel,OrderTakeProfit(),OrderExpiration(),PaleGreen);
         retError=GetLastError();
         if(retError!=0)
           {
            //Print(now+", ModifyStopLoss(),"+" Fail ModifyOrder() code"+retError);
           }
        }
      while(IsTradeContextBusy())
        {
         Sleep(100);
        }

     }
   return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RecordMaxGAINLOSS()
  {
   string t;

   if(pl>max_gain && pl>0) max_gain=pl;
   if(pl<max_loss && pl<0) max_loss=pl;

   if(max_loss!=0) RRR=MathAbs(max_gain/max_loss);  else RRR=-1;
   t="RRR"+DoubleToStr(RRR,2)+", MAXG"+DoubleToStr(max_gain,1)+", MAXL"+DoubleToStr(max_loss,1);

   status(t);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OrderOpenTooLongAndNotMove()
  {
   if(TimeCurrent()-laststamp>hr_sec(2) && TimeCurrent()-laststamp>hr_sec(8) && RRR!=0)
     {
      if(1/RRR>=1.5 && -max_loss>=10 && pl>=5)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,DarkGray)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC1");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+15*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+15*60;
           }
        }
     }

   if(TimeCurrent()-laststamp>hr_sec(3) && RRR!=0)
     {
      if(1/RRR>=5 && -max_loss>=10 && pl>=-20)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Goldenrod)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:OrderOpenTooLongAndNotMove(), LOGIC2");
            if(MachineState==state_buy1) BlockBuyUntilTime=TimeCurrent()+15*60;
            if(MachineState==state_sell1) BlockSellUntilTime=TimeCurrent()+15*60;
           }
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BuyThenImmediateProfit()
  {
   bool stochOBOS=false;
   double piptotake;
//piptotake=xpips(fastATR);
   piptotake=10;
//if(xpips(fastATR)<=10)   piptotake=5;
   if(TimeCurrent()-laststamp<hr_sec(1))
     {
      if(pl>=piptotake)
        {
         if(OrderClose(lastticket,OrderLots(),Bid,5,Olive)==true)
           {
            Print("Close order#"+IntegerToString(lastticket)+", REASON:BuyThenImmediateProfit()");
            if(MachineState==state_buy1)
              {
               BlockBuyUntilTime=TimeCurrent()+15*60;
               //MachineState=state_revbuy_tradesell;
              }
            if(MachineState==state_sell1)
              {
               BlockSellUntilTime=TimeCurrent()+15*60;
               //MachineState=state_revsell_tradebuy;
              }
           }

        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CummPL()
  {
   string t;
   switch(MachineState)
     {
      case state_buy2:
        {
         cummpl=Bid-thisBreakEven;
         break;
        }
      case state_sell2:
        {
         cummpl=thisBreakEven-Ask;
         break;
        }
     }
   cummpl=cummpl*MathPow(10,Digits-1);
   t="Cumm PL (pips)="+DoubleToStr(cummpl,2);
   status(t);
  }
//#runcomment
void Run_Comment()
  {
//----Signal Watchs & Infomartion/Comment
   switch(MachineState)
     {
      case state_idle:
        {
         //----MachineState info
         status("wating for signal...");

         break;
        }
      case state_buy1:
        {
         status(".. trailing stop loss for buy pos");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         RecordMaxGAINLOSS();

         break;
        }
      case state_sell1:
        {
         status(".. trailing stop loss for sell pos");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         RecordMaxGAINLOSS();

         break;
        }
      case state_await_buy:
        {
         status(".. trailing stop loss for buy pos");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case state_await_sell:
        {
         status(".. trailing stop loss for sell pos");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
      case state_buy2:
        {
         status(".. recovery buy mode");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         showmycomment_ListOrder_buy();
         CummPL();
         break;
        }
      case state_sell2:
        {
         status(".. recovery sell mode");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         showmycomment_ListOrder_sell();
         CummPL();
         break;
        }
      case state_buy2_hold:
        {
         status(".. recovery buy mode");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         showmycomment_ListOrder_buy();
         CummPL();
         break;
        }
      case state_sell2_hold:
        {
         status(".. recovery sell mode");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         showmycomment_ListOrder_sell();
         CummPL();
         break;
        }

      case state_revbuy_tradesell:
        {
         status(".. reversing from buy to sell mode");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
      case state_revsell_tradebuy:
        {
         status(".. reversing from sell to buy mode");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case  state_revbuy_tradesell_trail:
        {
         status(".. trailing stop loss for reversed-side order, buy mode");

         showmycomment_timeunlocked_buy();
         showmycomment_LastTicket();
         break;
        }
      case  state_revsell_tradebuy_trail:
        {
         status(".. trailing stop loss for reversed-side order, sell mode");

         showmycomment_timeunlocked_sell();
         showmycomment_LastTicket();
         break;
        }
     }

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_State_Transition()
  {
   switch(MachineState)
     {
      case state_idle:
        {
         break;
        }
      case state_buy1:
        {
         break;
        }
      case state_sell1:
        {
         break;
        }
      case state_await_buy:
        {
         break;
        }
      case state_await_sell:
        {
         break;
        }
      case state_buy2:
        {
         break;
        }
      case state_sell2:
        {
         break;
        }
      case state_buy2_hold:
        {
         break;
        }
      case state_sell2_hold:
        {
         break;
        }
      case state_revbuy_tradesell:
        {
         break;
        }
      case state_revsell_tradebuy:
        {
         break;
        }
      case state_revbuy_tradesell_trail:
        {
         break;
        }
      case state_revsell_tradebuy_trail:
        {
         break;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_TimeStampControl()
  {
   switch(MachineState)
     {
      case state_idle:                 laststamp=timestamp_close;    break;
      case state_buy1:                 laststamp=timestamp_buy;      break;
      case state_sell1:                laststamp=timestamp_sell;     break;
      case state_await_buy:            laststamp=timestamp_buy;      break;
      case state_await_sell:           laststamp=timestamp_sell;     break;
      case state_buy2:
        {
         laststamp=timestamp_buy;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_buy;
         //MultiOrderState_Age=(datetime)(TimeCurrent()-MultiOrderStateTimeStamp);
         break;
        }
      case state_sell2:
        {
         laststamp=timestamp_sell;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_sell;
         //MultiOrderState_Age=(datetime)(TimeCurrent()-MultiOrderStateTimeStamp);
         break;
        }
      case state_buy2_hold:
        {
         laststamp=timestamp_buy;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_buy;
         //MultiOrderState_Age=(datetime)(TimeCurrent()-MultiOrderStateTimeStamp);
         break;
        }
      case state_sell2_hold:
        {
         laststamp=timestamp_sell;      MultiOrderStateTimeStamp=MultiOrderStateTimeStamp_sell;
         //MultiOrderState_Age=(datetime)(TimeCurrent()-MultiOrderStateTimeStamp);
         break;
        }
      case state_revbuy_tradesell:          laststamp=timestamp_buy;      break;
      case state_revsell_tradebuy:         laststamp=timestamp_sell;     break;
      case state_revbuy_tradesell_trail:    laststamp=timestamp_buy;      break;
      case state_revsell_tradebuy_trail:   laststamp=timestamp_sell;     break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_CurrentStateShortCode()
  {
   switch(MachineState)
     {
      case state_idle:                 now="I";    break;
      case state_ecn_buyaddstop:                 now="BSL";    break;
      case state_ecn_buyaddtp:                 now="BTP";    break;
      case state_ecn_selladdstop:                 now="SSL";    break;
      case state_ecn_selladdtp:                 now="STP";    break;
      case state_buy1:                 now="B1";    break;
      case state_sell1:                now="S1";    break;
      case state_await_buy:            now="B0";    break;
      case state_await_sell:            now="S0";    break;
      case state_buy2:                 now="B2";    break;
      case state_sell2:                now="S2";    break;
      case state_buy2_hold:                 now="B2H";    break;
      case state_sell2_hold:                now="S2H";    break;
      case state_revbuy_tradesell:          now="RB";      break;
      case state_revsell_tradebuy:         now="RS";      break;
      case state_revbuy_tradesell_trail:    now="RBT";   break;
      case state_revsell_tradebuy_trail:   now="RST";   break;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run_OrderCommand()
  {
   switch(MachineState)
     {
      case state_idle:                 CMD=-1;    break;
      case state_buy1:                 CMD=OP_BUY;    break;
      case state_sell1:                CMD=OP_SELL;    break;
      case state_await_buy:            CMD=OP_BUY;    break;
      case state_await_sell:           CMD=OP_SELL;    break;
      case state_buy2:                 CMD=OP_BUY;    break;
      case state_sell2:                CMD=OP_SELL;    break;
      case state_buy2_hold:                 CMD=OP_BUY;    break;
      case state_sell2_hold:                CMD=OP_SELL;    break;
      case state_revbuy_tradesell:         CMD=OP_SELL;    break;
      case state_revsell_tradebuy:         CMD=OP_BUY;    break;
      case state_revbuy_tradesell_trail:   CMD=OP_SELL;    break;
      case state_revsell_tradebuy_trail:   CMD=OP_BUY;    break;
     }
  }
//+------------------------------------------------------------------+
bool checksametp(int mn,int side)
  {
   bool retval=true;
   double tp=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderMagicNumber()==mn && OrderSymbol()==Symbol() && OrderType()==side)
           {
            if(tp==0)
              {
               tp=OrderTakeProfit();
               break;
              }
            if(tp!=0 && tp!=OrderTakeProfit())
              {
               retval=false;
              }
           }
        }
     }
   return(retval);
  }
//+------------------------------------------------------------------+
string text_lotsize()
  {
   return("adj="+DoubleToString(selecting_lot_size,2)+"/exe="+DoubleToString(execute_lot_size,2));
  }
//+------------------------------------------------------------------+
void UpdateStateNumber()
  {
   LabelTextChange(0,"statestext","STATE="+IntegerToString(MachineState));
  }
//+------------------------------------------------------------------+
